/**********************************************************
FileName:    DlgDeviceInfo.cpp
Description: device basic info  
Date:        2008/05/17
Note: 		<global>struct, define refer to GeneralDef.h, global variables and functions refer to ClientDemo.cpp   
Modification History:      
    <version> <time>         <desc>
    <1.0    > <2008/05/17>       <created>
***********************************************************/

#include "stdafx.h"
#include "ClientDemo.h"
#include "DlgDeviceInfo.h"
#include ".\dlgdeviceinfo.h"


// CDlgDeviceInfo dialog
/*********************************************************
  Function:	CDlgDeviceInfo
  Desc:		Constructor
  Input:	
  Output:	
  Return:	
**********************************************************/
IMPLEMENT_DYNAMIC(CDlgDeviceInfo, CDialog)
CDlgDeviceInfo::CDlgDeviceInfo(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgDeviceInfo::IDD, pParent)
	, m_csLocalNodeName(_T(""))
	, m_csUserName(_T(""))
	, m_csPwd(_T(""))
	, m_iPort(0)
	, m_csMultiIP(_T(""))
	, m_iChanNum(0)
	, m_csSerialNo(_T(""))
	//, m_csIPOnIPServer(_T(""))
	, m_iDeviceIndex(-1)
{
}

/*********************************************************
  Function:	~CDlgDeviceInfo
  Desc:		destructor
  Input:	
  Output:	
  Return:	
**********************************************************/
CDlgDeviceInfo::~CDlgDeviceInfo()
{
}

/*********************************************************
  Function:	DoDataExchange
  Desc:		map between control and data
  Input:	
  Output:	
  Return:	
**********************************************************/
void CDlgDeviceInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgDeviceInfo)
	DDX_Text(pDX, IDC_DEVINFO_DEVICE_NAME, m_csLocalNodeName);
	DDX_Text(pDX, IDC_DEVINFO_USERNAME, m_csUserName);
	DDX_Control(pDX, IDC_DEVINFO_IP, m_ctrlIPAddr);
	DDX_Text(pDX, IDC_DEVINFO_DEVICE_PWD, m_csPwd);
	DDX_Text(pDX, IDC_DEVINFO_PORT, m_iPort);
	DDX_Text(pDX, IDC_DEVINFO_MULTIIP, m_csMultiIP);
	DDX_Text(pDX, IDC_DEVINFO_CHANNEL_NUM, m_iChanNum);
	DDX_Control(pDX, IDC_COMBO_DEVINFO_DEV_TYPE, m_comboDeviceType);
	DDX_Text(pDX, IDC_DEVINFO_SERIALNUM, m_csSerialNo);
    //}}AFX_DATA_MAP
}

/*********************************************************
  Function:	BEGIN_MESSAGE_MAP
  Desc:		map between message and function
  Input:	
  Output:	
  Return:	
**********************************************************/
BEGIN_MESSAGE_MAP(CDlgDeviceInfo, CDialog)
	//{{AFX_MSG_MAP(CDlgDeviceInfo)
	ON_BN_CLICKED(IDC_DEVINFO_OK, OnBnClickedDevinfoOk)
	ON_BN_CLICKED(IDC_DEVINFO_CANCEL, OnBnClickedDevinfoCancel)
	//}}AFX_MSG_MAP	
END_MESSAGE_MAP()


/*********************************************************
  Function:	OnInitDialog
  Desc:		initialize dialog
  Input:	
  Output:	
  Return:	
**********************************************************/
BOOL CDlgDeviceInfo::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_iTypeNum = 0;
	m_comboDeviceType.ResetContent();
	m_comboDeviceType.AddString("DVR");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR);
	m_iTypeNum++;
	m_comboDeviceType.AddString("ATMDVR");
	m_comboDeviceType.SetItemData(m_iTypeNum, ATMDVR);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVS");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVS);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DEC");
	m_comboDeviceType.SetItemData(m_iTypeNum, DEC);
	m_iTypeNum++;
	m_comboDeviceType.AddString("ENC_DEC");
	m_comboDeviceType.SetItemData(m_iTypeNum, ENC_DEC);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HC");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HC);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HT");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HT);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HF");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HF);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HS");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HS);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HTS");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HTS);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HB");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HB);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HCS");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HCS);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVS_A");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVS_A);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HC_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HC_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HT_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HT_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HF_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HS_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HS_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("ATMDVR_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, ATMDVR_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("LOWCOST_DVR");
	m_comboDeviceType.SetItemData(m_iTypeNum, LOWCOST_DVR);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DEC_MAT");
	m_comboDeviceType.SetItemData(m_iTypeNum, DEC_MAT);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_MOBILE");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_MOBILE);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HD_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HD_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HD_SL");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HD_SL);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HC_SL");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HC_SL);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HS_ST");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HS_ST);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVS_HW");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVS_HW);
	m_iTypeNum++;
	m_comboDeviceType.AddString("IPCAM");
	m_comboDeviceType.SetItemData(m_iTypeNum, IPCAM);
	m_iTypeNum++;
	m_comboDeviceType.AddString("MEGA_IPCAM");
	m_comboDeviceType.SetItemData(m_iTypeNum, MEGA_IPCAM);
	m_iTypeNum++;
	m_comboDeviceType.AddString("IPCAM_X62MF");
	m_comboDeviceType.SetItemData(m_iTypeNum, IPCAM_X62MF);
	m_iTypeNum++;
	m_comboDeviceType.AddString("IPDOME");
	m_comboDeviceType.SetItemData(m_iTypeNum, IPDOME);
	m_iTypeNum++;
	m_comboDeviceType.AddString("IPMOD");
	m_comboDeviceType.SetItemData(m_iTypeNum, IPMOD);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS71XX_H");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS71XX_H);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS72XX_H_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS72XX_H_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS73XX_H_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS73XX_H_S);
	m_iTypeNum++;

	m_comboDeviceType.AddString("DS81XX_HS_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HS_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_HL_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HL_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_HC_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HC_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_HD_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HD_S);
	m_iTypeNum++;
	
	m_comboDeviceType.AddString("DS81XX_HE_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HE_S);
	m_iTypeNum++;


	m_comboDeviceType.AddString("DS81XX_HF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HF_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_AH_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_AH_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_AHF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_AHF_S);
	m_iTypeNum++;
	
	m_comboDeviceType.AddString("DS90XX_HF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS90XX_HF_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS91XX_HF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS91XX_HF_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS91XX_HD_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS91XX_HD_S);
	m_iTypeNum++;
	if (g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum == -1)
	{
		m_iChanNum= 16;
		m_iPort = 8000;
		m_comboDeviceType.SetCurSel(0);
	}
	else
	{
		m_csLocalNodeName.Format("%s",g_struDeviceInfo[m_iDeviceIndex].chLocalNodeName);
		m_csUserName.Format("%s",g_struDeviceInfo[m_iDeviceIndex].chLoginUserName);
		m_csPwd.Format("%s",g_struDeviceInfo[m_iDeviceIndex].chLoginPwd);
		m_iChanNum = g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum;
		m_ctrlIPAddr.SetAddress(CStringTodwIP(g_struDeviceInfo[m_iDeviceIndex].chDeviceIP));
		m_csMultiIP.Format(g_struDeviceInfo[m_iDeviceIndex].chDeviceMultiIP);
		m_iPort = g_struDeviceInfo[m_iDeviceIndex].lDevicePort;
		for (int i=0; i<m_iTypeNum; i++)
		{
			if (m_comboDeviceType.GetItemData(i) == g_struDeviceInfo[m_iDeviceIndex].iDeviceType)
			{
				m_iSelType = i;
				break;
			}
		}
		m_comboDeviceType.SetCurSel(m_iSelType);
		m_csSerialNo.Format("%s", g_struDeviceInfo[m_iDeviceIndex].chSerialNumber);
	}
	UpdateData(FALSE);
	return TRUE;
}

/*********************************************************
  Function:	OnBnClickedDevinfoOk
  Desc:		finish modifying device info and exit
  Input:	
  Output:	
  Return:	
**********************************************************/
void CDlgDeviceInfo::OnBnClickedDevinfoOk()
{
	UpdateData(TRUE);
	DWORD dwDeviceIP = 0;
	m_ctrlIPAddr.GetAddress(dwDeviceIP);
	CString csIP = IPToStr(dwDeviceIP);
	sprintf(g_struDeviceInfo[m_iDeviceIndex].chDeviceIP, "%s", csIP.GetBuffer(0));
	sprintf(g_struDeviceInfo[m_iDeviceIndex].chLocalNodeName, "%s", m_csLocalNodeName.GetBuffer(0));
	g_struDeviceInfo[m_iDeviceIndex].lDevicePort = m_iPort;
	sprintf(g_struDeviceInfo[m_iDeviceIndex].chLoginPwd, "%s", m_csPwd.GetBuffer(0));
	sprintf(g_struDeviceInfo[m_iDeviceIndex].chLoginUserName, "%s", m_csUserName.GetBuffer(0));
	
//update node name in main dialog
	CDialog::OnOK();
}

/*********************************************************
  Function:	OnBnClickedDevinfoCancel
  Desc:		exit device info box
  Input:	
  Output:	
  Return:	
**********************************************************/
void CDlgDeviceInfo::OnBnClickedDevinfoCancel()
{
	CDialog::OnCancel();
}
