/**********************************************************
FileName:    DlgDeviceState.cpp
Description: device state dialog, in 'configuration' function     
Date:        2008/05/17
Note: 		 <global>struct, define refer to GeneralDef.h, global variables and functions refer to ClientDemo.cpp     
Modification History:      
    <version> <time>         <desc>
    <1.0    > <2008/05/17>       <created>
***********************************************************/


#include "stdafx.h"
#include "ClientDemo.h"
#include "DlgDeviceState.h"
#include ".\dlgdevicestate.h"

/*********************************************************
  Function:	CDlgDeviceState
  Desc:		Constructor
  Input:	
  Output:	
  Return:	
**********************************************************/
IMPLEMENT_DYNAMIC(CDlgDeviceState, CDialog)
CDlgDeviceState::CDlgDeviceState(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgDeviceState::IDD, pParent)
	, m_csLocalNodeName(_T(""))
	, m_csDeviceState(_T(""))
	, m_iDeviceIndex(-1)
	, m_csRecState(_T(""))
	, m_csSignalState(_T(""))
	, m_csHardWareState(_T(""))
	, m_csBitrate(_T(""))
	, m_csDiskVolume(_T(""))
	, m_csDiskFreeSpace(_T(""))
	, m_csDiskState(_T(""))
	, m_lLoginID(-1)
	, m_csDeviceIP(_T(""))
{
}

/*********************************************************
  Function:	~CDlgDeviceState
  Desc:		destructor
  Input:	
  Output:	
  Return:	
**********************************************************/
CDlgDeviceState::~CDlgDeviceState()
{
}

/*********************************************************
  Function:	DoDataExchange
  Desc:		map between control and variable
  Input:	
  Output:	
  Return:	
**********************************************************/
void CDlgDeviceState::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgDeviceState)
//	DDX_Text(pDX, IDC_STATIC_DEVNAME, m_csLocalNodeName);
//	DDX_Text(pDX, IDC_STATIC_DEVSTATE, m_csDeviceState);
	DDX_Control(pDX, IDC_LIST_CHAN_STATE, m_listChanState);
	DDX_Control(pDX, IDC_LIST_DISK_STATE, m_listDiskState);
	DDX_Text(pDX, IDC_STATIC_DEV_STATE_IP, m_csDeviceIP);
    //}}AFX_DATA_MAP
}

/*********************************************************
  Function:	BEGIN_MESSAGE_MAP
  Desc:		map between control and function
  Input:	
  Output:	
  Return:	
**********************************************************/
BEGIN_MESSAGE_MAP(CDlgDeviceState, CDialog)
	//{{AFX_MSG_MAP(CDlgDeviceState)
	ON_BN_CLICKED(ID_BTN_REFRESH, OnBnClickedBtnRefresh)
	ON_BN_CLICKED(IDC_BTN_EXIT, OnBtnExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/*********************************************************
  Function:	OnInitDialog
  Desc:		initialize device state box
  Input:	
  Output:	
  Return:	
**********************************************************/
BOOL CDlgDeviceState::OnInitDialog()
{
	CDialog::OnInitDialog();
	CenterWindow();
	char szLan[128] = {0};
	g_StringLanType(szLan, "ͨ", "Chan No.");
	m_listChanState.InsertColumn(0, szLan, LVCFMT_LEFT, 90, -1);
	g_StringLanType(szLan, "¼״̬", "Record Status");
	m_listChanState.InsertColumn(1, szLan, LVCFMT_LEFT, 100, -1);
	g_StringLanType(szLan, "ź״̬", "Signal Status");
	m_listChanState.InsertColumn(2, szLan, LVCFMT_LEFT, 100, -1);
	g_StringLanType(szLan, "Ӳ״̬", "Hardware Status");
	m_listChanState.InsertColumn(3, szLan, LVCFMT_LEFT, 100, -1);
	g_StringLanType(szLan, "", "Record Status");
	m_listChanState.InsertColumn(4, szLan, LVCFMT_LEFT, 80, -1);
	g_StringLanType(szLan, "ǰ(bps)", "Record Status");
	m_listChanState.InsertColumn(5, szLan,LVCFMT_LEFT,110, -1);
	g_StringLanType(szLan, "IPC", "Record Status");
	m_listChanState.InsertColumn(6, szLan,LVCFMT_LEFT,80, -1);

	g_StringLanType(szLan, "Ӳ̺", "HD No.");
	m_listDiskState.InsertColumn(0, szLan, LVCFMT_LEFT, 90, -1);
	g_StringLanType(szLan, "Ӳ(MB)", "HD Capacity");
	m_listDiskState.InsertColumn(1, szLan, LVCFMT_LEFT, 130, -1);
	g_StringLanType(szLan, "ʣռ(MB)", "Last Capacity");
	m_listDiskState.InsertColumn(2, szLan, LVCFMT_LEFT, 130, -1);
	g_StringLanType(szLan, "Ӳ״̬", "HD Status");
	m_listDiskState.InsertColumn(3, szLan, LVCFMT_LEFT,250,-1);

	m_listChanState.SetExtendedStyle(m_listChanState.GetExtendedStyle()|LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);
	m_listDiskState.SetExtendedStyle(m_listDiskState.GetExtendedStyle()|LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);
	CheckInitParam();
	return TRUE;
}

/*********************************************************
  Function:	OnBnClickedBtnRefresh
  Desc:		refresh device state info
  Input:	
  Output:	
  Return:	
**********************************************************/
void CDlgDeviceState::OnBnClickedBtnRefresh()
{
	int i = 0;
	int iIndex = 0;
	int iTotalLen = 0;
	CString strDiskNum = _T("");
	CString strChanNum = _T("");
	CString strTemp = _T("");
	char szLan[1024] = {0};

	m_listChanState.DeleteAllItems();
	m_listDiskState.DeleteAllItems();

	NET_DVR_WORKSTATE_V30 struWorkState;
	memset(&struWorkState, 0, sizeof(NET_DVR_WORKSTATE_V30));
	if (!NET_DVR_GetDVRWorkState_V30(g_struDeviceInfo[m_iDeviceIndex].lLoginID, &struWorkState))
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GetDVRWorkState_V30");
		g_StringLanType(szLan, "ȡ豸״̬ʧ!", "Get Device Status Err!");
		AfxMessageBox(szLan);
		return;
	}

	switch (struWorkState.dwDeviceStatic) 
	{
	case 0:
		g_StringLanType(szLan, "", "Normal");
		m_csDeviceState.Format(szLan);
		break;
	case 1:
		g_StringLanType(szLan, "CPUռ̫,85%", "CPU occupancy rate is too high");
		m_csDeviceState.Format(szLan);
		break;
	case 2:
		g_StringLanType(szLan, "Ӳ", "Hardware error");
		m_csDeviceState.Format(szLan);
		break;
	default:
		ASSERT(struWorkState.dwDeviceStatic < 3);
		break;
	}

	GetDlgItem(IDC_STATIC_DEVSTATE)->SetWindowText(m_csDeviceState);

	if (0 == struWorkState.byAudioChanStatus[0])
	{
		//m_csSignalState.Format("δʹ");
	}
	else if (1 == struWorkState.byAudioChanStatus[0])
	{
		//m_csSignalState.Format("ʹ");
	}

	//monitoring point state
	for (i = 0; i < MAX_CHANNUM_V30; i++)  //
	{
		if (!g_struDeviceInfo[m_iDeviceIndex].struChanInfo[i].bEnable)
		{
			continue;
		}

		if (i < g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum)
		{
			strChanNum.Format(ANALOG_C_FORMAT, i+g_struDeviceInfo[m_iDeviceIndex].iStartChan);	
		}
		else if ( i>=MAX_ANALOG_CHANNUM)
		{
			strChanNum.Format(DIGITAL_C_FORMAT, i+g_struDeviceInfo[m_iDeviceIndex].iStartChan-MAX_ANALOG_CHANNUM);	
		}

		if (0 == struWorkState.struChanStatic[i].byRecordStatic)
		{
			g_StringLanType(szLan, "¼", "Not Record");
			m_csRecState.Format(szLan);
		}
		else if (1 == struWorkState.struChanStatic[i].byRecordStatic)
		{
			g_StringLanType(szLan, "¼", "Record");
			m_csRecState.Format(szLan);
		}

		if (0 == struWorkState.struChanStatic[i].bySignalStatic)
		{
			g_StringLanType(szLan, "", "Normal");
			m_csSignalState.Format(szLan);
		}
		else if (1 == struWorkState.struChanStatic[i].bySignalStatic)
		{
			g_StringLanType(szLan, "źŶʧ", "Signal loss");
			m_csSignalState.Format(szLan);
		}

		if ( 0 == struWorkState.struChanStatic[i].byHardwareStatic)
		{
			g_StringLanType(szLan, "", "Normal");
			m_csHardWareState.Format(szLan);
		}
		else if (1 == struWorkState.struChanStatic[i].byHardwareStatic)
		{
			g_StringLanType(szLan, "쳣", "Abnormal");
			m_csHardWareState.Format(szLan);
		}

		m_csLinkCount.Format("%d", struWorkState.struChanStatic[i].dwLinkNum);
		iTotalLen+=struWorkState.struChanStatic[i].dwLinkNum;
		m_csBitrate.Format("%ld", struWorkState.struChanStatic[i].dwBitRate);
		//strTemp.Format("%d", );
		m_listChanState.InsertItem(iIndex, strChanNum, 0);
		m_listChanState.SetItemText(iIndex, 1, m_csRecState);
		m_listChanState.SetItemText(iIndex, 2, m_csSignalState);
		m_listChanState.SetItemText(iIndex, 3, m_csHardWareState);
		m_listChanState.SetItemText(iIndex, 4, m_csLinkCount);
		m_listChanState.SetItemText(iIndex, 5, m_csBitrate);
		strTemp.Format("%d", struWorkState.struChanStatic[i].dwIPLinkNum);
		m_listChanState.SetItemText(iIndex, 6, strTemp);
		iIndex++;
	}

	//disk state
	for (i = 0; i < MAX_DISKNUM_V30; i++)
	{
		g_StringLanType(szLan, "Ӳ", "HD");
		strDiskNum.Format("%s%02d", szLan, i+1);

		m_csDiskVolume.Format("%ld", struWorkState.struHardDiskStatic[i].dwVolume);
		m_csDiskFreeSpace.Format("%ld", struWorkState.struHardDiskStatic[i].dwFreeSpace);

		if (struWorkState.struHardDiskStatic[i].dwVolume != 0)
		{
			switch (struWorkState.struHardDiskStatic[i].dwHardDiskStatic) 
			{
			case 0:
				g_StringLanType(szLan, "", "Active");
				m_csDiskState.Format(szLan);
				break;
			case 1:
				g_StringLanType(szLan, "", "Dormancy");
				m_csDiskState.Format(szLan);
				break;
			case 2:
				g_StringLanType(szLan, "", "Abnormal");
				m_csDiskState.Format(szLan);
				m_csDiskState.Format("%s", "");
				break;
// 			case 3:		
// 				g_StringLanType(szLan, "Ҳ", "Dormancy and Abnormal");
// 				m_csDiskState.Format(szLan);
// 				break;
			default:
				ASSERT(struWorkState.struHardDiskStatic[i].dwHardDiskStatic >= 0 &&\
					struWorkState.struHardDiskStatic[i].dwHardDiskStatic < 4);
				break;
			}
		}else
		{
			m_csDiskState.Format("");
		}

		strTemp.Format("%d",i);
		m_listDiskState.InsertItem(i,strDiskNum,0);
		m_listDiskState.SetItemText(i,1,m_csDiskVolume);
		m_listDiskState.SetItemText(i,2,m_csDiskFreeSpace);
		m_listDiskState.SetItemText(i,3,m_csDiskState);
	}

	strTemp.Format("%d",iTotalLen);
	GetDlgItem(IDC_STATIC_TOTAL_LINK)->SetWindowText(strTemp);

	UpdateData(false);
}

/*********************************************************
  Function:	CheckInitParam
  Desc:		check current selected device, and initialize parameters in the dialog
  Input:	
  Output:	
  Return:	TRUE,checked and got state info;FALSE,failed;
**********************************************************/
BOOL CDlgDeviceState::CheckInitParam(void)
{
	int iDeviceIndex = g_pMainDlg->GetCurDeviceIndex();

	if (iDeviceIndex == -1)
	{
		m_lLoginID = -1;
		GetDlgItem(IDC_BTN_REFRESH)->EnableWindow(FALSE);
		return FALSE;
	}

	if (m_iDeviceIndex == iDeviceIndex)
	{
		return TRUE;
	}
	else
	{
		m_iDeviceIndex = iDeviceIndex;
		m_listChanState.DeleteAllItems();
		m_listDiskState.DeleteAllItems();
	}

	m_lLoginID = g_struDeviceInfo[m_iDeviceIndex].lLoginID;

	if (m_lLoginID < 0)
	{
		GetDlgItem(IDC_BTN_REFRESH)->EnableWindow(FALSE);
		return FALSE;
	}
	m_csLocalNodeName.Format("%s", g_struDeviceInfo[m_iDeviceIndex].chLocalNodeName);//device title:
	m_csDeviceIP.Format("%s", g_struDeviceInfo[m_iDeviceIndex].chDeviceIP);//device IP address:
	GetDlgItem(IDC_STATIC_DEVNAME)->SetWindowText(m_csLocalNodeName);
	OnBnClickedBtnRefresh();
	EnableWindow(TRUE);
	return TRUE;
}

/*********************************************************
  Function:	OnBtnExit
  Desc:		exit the dialog
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgDeviceState::OnBtnExit() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();
}
