/**********************************************************
FileName:    DlgHardDiskCfg.cpp
Description:  disk config    
Date:        2008/06/03
Note: 		 <global>struct, define refer to GeneralDef.h, global variables and functions refer to ClientDemo.cpp     
Modification History:      
    <version> <time>         <desc>
    <1.0    > <2008/06/03>       <created>
***********************************************************/
#include "stdafx.h"
#include "ClientDemo.h"
#include "DlgHardDiskCfg.h"
#include ".\dlgharddiskcfg.h"


// CDlgHardDiskCfg dialog
/*********************************************************
  Function:	CDlgHardDiskCfg
  Desc:		Constructor
  Input:	pParent, parent window pointer
  Output:	none
  Return:	none
**********************************************************/
IMPLEMENT_DYNAMIC(CDlgHardDiskCfg, CDialog)
CDlgHardDiskCfg::CDlgHardDiskCfg(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgHardDiskCfg::IDD, pParent)
	, m_iSelHDNum(0)
	, m_bChkCyclicRecord(FALSE)
	, m_iSpaceThreshold(0)
	, m_dwChanCount(0)
	, m_iHDAttr(0)
	, m_iSelGroup(0)
	, m_iSelHDIndex(0)
{
}

/*********************************************************
  Function:	~CDlgHardDiskCfg
  Desc:		Destructor
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
CDlgHardDiskCfg::~CDlgHardDiskCfg()
{
}

/*********************************************************
  Function:	DoDataExchange
  Desc:		the map between control and variable
  Input:	pDX, CDataExchange,pass the data exchange object to the window CWnd::DoDataExchange
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgHardDiskCfg)
	DDX_Control(pDX, IDC_LIST_DISK, m_listDisk);
	DDX_Control(pDX, IDC_LIST_CHAN, m_listChan);
	DDX_Control(pDX, IDC_COMBO_GROUP, m_comboGroup);
	DDX_Control(pDX, IDC_COMBO_BELONG_GROUP, m_comboBelongGroup);
	DDX_Control(pDX, IDC_COMBO_DISK, m_comboDisk);
	//DDX_Check(pDX, IDC_CHK_ALL_CHAN, m_bChkAllChan);
	//}}AFX_DATA_MAP
}

/*********************************************************
  Function:	BEGIN_MESSAGE_MAP
  Desc:		the map between control and function
  Input:	first parameter:name of current class; second: name of base class
  Output:	none
  Return:	none
**********************************************************/
BEGIN_MESSAGE_MAP(CDlgHardDiskCfg, CDialog)
	//{{AFX_MSG_MAP(CDlgHardDiskCfg)	
	ON_BN_CLICKED(IDC_BTN_ONE_HD_OK, OnBnClickedBtnOneHdOk)
	ON_BN_CLICKED(IDC_BTN_HD_REFRESH, OnBtnHdRefresh)
	ON_BN_CLICKED(IDC_RADIO_NONE, OnRadioNone)
	ON_BN_CLICKED(IDC_RADIO_READ_ONLY, OnRadioReadOnly)
	ON_BN_CLICKED(IDC_RADIO_REDUND, OnRadioRedund)
	ON_NOTIFY(NM_CLICK, IDC_LIST_DISK, OnClickListDisk)
	ON_NOTIFY(NM_CLICK, IDC_LIST_CHAN, OnClickListChan)
	ON_CBN_SELCHANGE(IDC_COMBO_GROUP, OnSelchangeComboGroup)
	ON_CBN_SELCHANGE(IDC_COMBO_DISK, OnSelchangeComboDisk)
	ON_BN_CLICKED(IDC_BTN_SET_GROUP, OnBtnSetGroup)
	ON_BN_CLICKED(IDC_CHK_ALL_CHAN, OnChkAllChan)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BTN_HD_SET, OnBtnHdSet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CDlgHardDiskCfg message handlers
/*********************************************************
  Function:	OnInitDialog
  Desc:		Initialize the dialog
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
BOOL CDlgHardDiskCfg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_listDisk.SetExtendedStyle(m_listDisk.GetExtendedStyle()|LVS_EX_FULLROWSELECT);
	char szLan[128] = {0};
	g_StringLanType(szLan, "", "HD Name");
	m_listDisk.InsertColumn(0,szLan,LVCFMT_LEFT,50,-1);
	g_StringLanType(szLan, "", "Capacity");
	m_listDisk.InsertColumn(1, szLan,LVCFMT_LEFT,140,-1);
	g_StringLanType(szLan, "ʣռ", "Last Capacity");
	m_listDisk.InsertColumn(2, szLan, LVCFMT_LEFT, 140,-1);
	g_StringLanType(szLan, "״̬", "HD Status");
	m_listDisk.InsertColumn(3, szLan, LVCFMT_LEFT,100,-1);
	g_StringLanType(szLan, "", "HD Group");
	m_listDisk.InsertColumn(4, szLan,LVCFMT_LEFT,50,-1);
	g_StringLanType(szLan, "", "Attr");
	m_listDisk.InsertColumn(5, szLan, LVCFMT_LEFT,120,-1);

	m_listChan.SetExtendedStyle(m_listChan.GetExtendedStyle()|LVS_EX_CHECKBOXES);
	return TRUE;  
}

/*********************************************************
  Function: CheckInitParam	
  Desc:		check and initialize the paramters
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::CheckInitParam()
{
	CString csTemp;
	int i = 0;
	DWORD dwReturned = 0;
	char szLan[32] = {0};
	m_iSelHDNum = 0;
	m_iSelHDIndex = 0;
	ShowWindow(SW_SHOW);
	i = g_pMainDlg->GetCurDeviceIndex();
	if (i == -1||g_pMainDlg->IsCurDevMatDec(i))
	{
		EnableWindow(FALSE);
		return;
	}

	EnableWindow(TRUE);
	((CButton *)GetDlgItem(IDC_RADIO_NONE))->SetCheck(FALSE);
	((CButton *)GetDlgItem(IDC_RADIO_REDUND))->SetCheck(FALSE);
	((CButton *)GetDlgItem(IDC_RADIO_READ_ONLY))->SetCheck(FALSE);
	m_listDisk.DeleteAllItems();
	m_comboGroup.ResetContent();
	m_dwDevIndex = i;
	m_lLoginID = g_struDeviceInfo[m_dwDevIndex].lLoginID;
	if (!NET_DVR_GetDVRConfig(m_lLoginID, NET_DVR_GET_HDCFG, 0, &m_struHDCfg, sizeof(NET_DVR_HDCFG), &dwReturned))
	{
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_FAIL_T, "NET_DVR_GET_HDCFG"); 
		GetDlgItem(IDC_BTN_ONE_HD_OK)->EnableWindow(FALSE);
		if (NET_DVR_GetLastError() == NET_DVR_NOSUPPORT)
		{
			EnableWindow(FALSE);
		}
		return;
	}
	else
	{
		GetDlgItem(IDC_BTN_ONE_HD_OK)->EnableWindow(TRUE);
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_SUCC_T, "NET_DVR_GET_HDCFG"); 

		for (i = 0; i < m_struHDCfg.dwHDCount; i++)
		{
			csTemp.Format("%d", m_struHDCfg.struHDInfo[i].dwHDNo);
			m_listDisk.InsertItem(i, csTemp, 0);
			csTemp.Format("%dMB", m_struHDCfg.struHDInfo[i].dwCapacity);
			m_listDisk.SetItemText(i, 1, csTemp);
			csTemp.Format("%dMB", m_struHDCfg.struHDInfo[i].dwFreeSpace);
			m_listDisk.SetItemText(i, 2, csTemp);
			switch(m_struHDCfg.struHDInfo[i].dwHdStatus)//disk state 0-normal, 1-unformatted, 2-error, 3-SMART state, 4-unmatched, 5-idle
			{
			case 0:
				g_StringLanType(szLan, "", "Normal");
				csTemp.Format(szLan);
				break;
			case 1:
				g_StringLanType(szLan, "δʽ", "Unformat");
				csTemp.Format(szLan);
				break;
			case 2:
				g_StringLanType(szLan, "", "Error");
				csTemp.Format(szLan);
			    break;
			case 3:
				g_StringLanType(szLan, "SMART״̬", "Smart Status");
				csTemp.Format(szLan);
			    break;
			case 4:
				g_StringLanType(szLan, "ƥ", "Mismatch");
				csTemp.Format(szLan);
				break;
			case 5:
				g_StringLanType(szLan, "", "Sleep");
				csTemp.Format(szLan);
				break;
			default:
				g_StringLanType(szLan, "δ֪", "Unknow");
				csTemp.Format(szLan);
			    break;
			}
			m_listDisk.SetItemText(i, 3, csTemp);

			csTemp.Format("%d", m_struHDCfg.struHDInfo[i].dwHdGroup);
			m_listDisk.SetItemText(i, 4, csTemp);
			
			switch(m_struHDCfg.struHDInfo[i].byHDAttr)
			{
			case 0:
				g_StringLanType(szLan, "ͨ", "Normal");
				csTemp.Format(szLan);
				break;
			case 1:
				g_StringLanType(szLan, "", "redundancy");
				csTemp.Format(szLan);
				break;
			case 2:
				g_StringLanType(szLan, "ֻ", "Readonly");
				csTemp.Format(szLan);
			    break;
			default:
			    break;
			}
			m_listDisk.SetItemText(i, 5, csTemp);
			//save the index of hard disk
			m_listDisk.SetItemData(i,i);
		}
	}
	m_comboDisk.ResetContent();
	for (i=0; i<m_struHDCfg.dwHDCount; i++)
	{
		csTemp.Format("%d", m_struHDCfg.struHDInfo[i].dwHDNo);
		m_comboDisk.AddString(csTemp);
		m_comboDisk.SetItemData(i, m_struHDCfg.struHDInfo[i].dwHDNo);
	}
	m_iSelHDIndex = 0;
 	m_comboDisk.SetCurSel(m_iSelHDIndex);
 	m_iSelHDNum = m_comboDisk.GetItemData(m_iSelHDIndex);	

	m_comboBelongGroup.ResetContent();
	for (i=0; i<MAX_HD_GROUP; i++)
	{
		csTemp.Format("%d", i+1);
		m_comboBelongGroup.AddString(csTemp);
	}

	//get disk group configuration
	if (!NET_DVR_GetDVRConfig(m_lLoginID, NET_DVR_GET_HDGROUP_CFG, 0, &m_struHDGroupCfg, sizeof(NET_DVR_HDGROUP_CFG), &dwReturned))
	{
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_FAIL_T, "NET_DVR_GET_HDGROUP_CFG"); 
		GetDlgItem(IDC_BTN_SET_GROUP)->EnableWindow(FALSE);
		GetDlgItem(IDOK)->EnableWindow(FALSE);
		return;
	}
	else
	{
		GetDlgItem(IDC_BTN_SET_GROUP)->EnableWindow(TRUE);
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_SUCC_T, "NET_DVR_GET_HDGROUP_CFG"); 
		for (i=0; i<m_struHDGroupCfg.dwHDGroupCount; i++)
		{
			csTemp.Format("%d", m_struHDGroupCfg.struHDGroupAttr[i].dwHDGroupNo);
			m_comboGroup.AddString(csTemp);
			m_comboGroup.SetItemData(i, m_struHDGroupCfg.struHDGroupAttr[i].dwHDGroupNo);
		}
		m_iSelGroup = 0;
		m_comboGroup.SetCurSel(m_iSelGroup);
		m_iGroupNum = m_comboGroup.GetItemData(m_iSelGroup);
		UpdataChanStatus();
	}

	UpdateData(FALSE);
}

/*********************************************************
  Function:	UpdataChanStatus
  Desc:		update the status of all channels
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::UpdataChanStatus()
{
	int iIndex = 0;
	int i = 0;
	CString csTemp;
	m_listChan.DeleteAllItems();
	//get the whole state of all channels
	m_bChkAllChan = TRUE;
	for (i=0; i<MAX_CHANNUM_V30; i++)
	{
		if (g_struDeviceInfo[m_dwDevIndex].struChanInfo[i].bEnable)
		{
			if (!m_struHDGroupCfg.struHDGroupAttr[m_iSelGroup].byHDGroupChans[i])
			{
				m_bChkAllChan = FALSE;
				break;
			}
		}
	}

	//insert all channel node
	m_listChan.InsertItem(iIndex, "All Chan");
	if (m_bChkAllChan)
	{
		m_listChan.SetCheck(iIndex, TRUE);
	}
	
	m_listChan.SetItemData(iIndex, 0xffff);
	iIndex ++;	

	for (i=0; i<MAX_CHANNUM_V30; i++)
	{
		if (g_struDeviceInfo[m_dwDevIndex].struChanInfo[i].bEnable)
		{
			if (i<g_struDeviceInfo[m_dwDevIndex].iDeviceChanNum)
			{
				csTemp.Format(ANALOG_C_FORMAT, g_struDeviceInfo[m_dwDevIndex].iStartChan+i);
			}
			else
			{
				csTemp.Format(DIGITAL_C_FORMAT, g_struDeviceInfo[m_dwDevIndex].iStartChan+i-MAX_ANALOG_CHANNUM);
			}
			
			m_listChan.InsertItem(iIndex, csTemp);
			if (m_struHDGroupCfg.struHDGroupAttr[m_iSelGroup].byHDGroupChans[i])
			{
				m_listChan.SetCheck(iIndex, TRUE);
			}
			
			m_listChan.SetItemData(iIndex, i);
			iIndex ++;			
		}
	}
}

/*********************************************************
  Function:	OnBnClickedBtnOneHdOk
  Desc:		save the current select disk config
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnBnClickedBtnOneHdOk()
{
	UpdateData(TRUE);
	CString csTemp = _T("");
	m_iSelHDIndex = m_comboDisk.GetCurSel();
	m_iSelHDNum = m_comboDisk.GetItemData(m_iSelHDIndex);//

	m_struHDCfg.struHDInfo[m_iSelHDIndex].byHDAttr = m_iHDAttr;
	m_struHDCfg.struHDInfo[m_iSelHDIndex].dwHdGroup = m_comboBelongGroup.GetCurSel()+1;
}

/*********************************************************
  Function:	OnBtnHdRefresh
  Desc:		refresh the paramters of the channels
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnBtnHdRefresh() 
{
	// TODO: Add your control notification handler code here
	CheckInitParam();
}

void CDlgHardDiskCfg::OnRadioNone() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_iHDAttr = 0;
	UpdateData(FALSE);
}

/*********************************************************
  Function:	OnRadioRedund
  Desc:		choose the redundancy attribute 
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnRadioRedund() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_iHDAttr = 1;
	UpdateData(FALSE);
}

/*********************************************************
  Function:	OnRadioReadOnly
  Desc:		choose the read-only attribute
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnRadioReadOnly() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_iHDAttr = 2;
	UpdateData(FALSE);
}

/*********************************************************
  Function:	SetRadioChk
  Desc:		set the attribute status
  Input:	iAttr, switch the status of the hard disk attributes
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::SetRadioChk(int iAttr)
{
	switch(iAttr)
	{
	case 0:
		((CButton *)GetDlgItem(IDC_RADIO_NONE))->SetCheck(TRUE);
		((CButton *)GetDlgItem(IDC_RADIO_REDUND))->SetCheck(FALSE);
		((CButton *)GetDlgItem(IDC_RADIO_READ_ONLY))->SetCheck(FALSE);
		break;
	case 1:
		((CButton *)GetDlgItem(IDC_RADIO_NONE))->SetCheck(FALSE);
		((CButton *)GetDlgItem(IDC_RADIO_REDUND))->SetCheck(TRUE);
		((CButton *)GetDlgItem(IDC_RADIO_READ_ONLY))->SetCheck(FALSE);
		break;
	case 2:
		((CButton *)GetDlgItem(IDC_RADIO_NONE))->SetCheck(FALSE);
		((CButton *)GetDlgItem(IDC_RADIO_REDUND))->SetCheck(FALSE);
		((CButton *)GetDlgItem(IDC_RADIO_READ_ONLY))->SetCheck(TRUE);
	    break;
	default:
	    break;
	}
}

/*********************************************************
  Function:	OnClickListDisk
  Desc:		update the control status of the choose disk
  Input:	pNMHDR, Contains the click information
  Output:	pResult, result after handle notification	
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnClickListDisk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
 	POSITION  iPos = m_listDisk.GetFirstSelectedItemPosition();
 	if (iPos == NULL)
 	{
 		return;
 	}
	CString csTmp;
	int iData = m_listDisk.GetItemData(m_listDisk.GetNextSelectedItem(iPos));
	m_iSelHDIndex = iData;
	m_struHDCfg.struHDInfo[m_iSelHDIndex].dwHdGroup;
	m_iSelHDNum = m_struHDCfg.struHDInfo[m_iSelHDIndex].dwHDNo;
	m_comboDisk.SetCurSel(m_iSelHDIndex);
	SetRadioChk(m_struHDCfg.struHDInfo[m_iSelHDIndex].byHDAttr);
	m_comboBelongGroup.SetCurSel(m_struHDCfg.struHDInfo[m_iSelHDIndex].dwHdGroup - 1);
	UpdateData(FALSE);
	*pResult = 0;
}

/*********************************************************
  Function:	OnClickListChan
  Desc:		update the status of the choosed channels
  Input:	pNMHDR, Contains the click information
  Output:	pResult, result after handle notification	
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnClickListChan(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData(TRUE);
	
	//POSITION  iPos = m_listChan.GetFirstSelectedItemPosition();//is not useful for small icon list
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	DWORD dwPos = GetMessagePos();
	CPoint point( LOWORD(dwPos), HIWORD(dwPos));

	m_listChan.ScreenToClient(&point);
 	
	UINT uFlag = 0;
	int iSel = m_listChan.HitTest(point, &uFlag);//
	if (iSel < 0)
	{
		return;
	}

	CString csTmp;
	int iData = m_listChan.GetItemData(iSel);
	if (iData == 0xffff)
	{
		m_bChkAllChan = !m_bChkAllChan;
		if (uFlag == LVHT_ONITEMLABEL)
		{
			m_listChan.SetCheck(iSel, m_bChkAllChan);
		}
		OnChkAllChan();
		return;
	}
	if (m_listChan.GetCheck(iSel))
	{
		m_struHDGroupCfg.struHDGroupAttr[m_iSelGroup].byHDGroupChans[iData] = 0;
	}
	else
	{
		m_struHDGroupCfg.struHDGroupAttr[m_iSelGroup].byHDGroupChans[iData] = 1;
	}
	
	if (uFlag == LVHT_ONITEMLABEL)
	{
		m_listChan.SetCheck(iSel, m_struHDGroupCfg.struHDGroupAttr[m_iSelGroup].byHDGroupChans[iData]);
	}
	UpdateData(FALSE);

	*pResult = 0;
}

/*********************************************************
  Function:	OnSelchangeComboGroup
  Desc:		update the group index
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnSelchangeComboGroup() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_iSelGroup = m_comboGroup.GetCurSel();
	m_iGroupNum = m_comboGroup.GetItemData(m_iSelGroup);
	UpdataChanStatus();
}

/*********************************************************
  Function:	OnSelchangeComboDisk
  Desc:		none
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnSelchangeComboDisk() 
{
	// TODO: Add your control notification handler code here
	
}

/*********************************************************
  Function:	OnBtnSetGroup
  Desc:		setup the configure of the hard disk group
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnBtnSetGroup() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString csTemp = _T("");
	m_iSelGroup = m_comboGroup.GetCurSel();
	m_iGroupNum = m_comboGroup.GetItemData(m_iSelGroup);
	char szLan[128] = {0};
	if (!NET_DVR_SetDVRConfig(m_lLoginID, NET_DVR_SET_HDGROUP_CFG, 0, &m_struHDGroupCfg, sizeof(NET_DVR_HDGROUP_CFG)))
	{
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_FAIL_T, "NET_DVR_SET_HDGROUP_CFG"); 
		g_StringLanType(szLan, "ʧ", "Save parameter failed");
		AfxMessageBox(szLan);
	}
	else
	{
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_SUCC_T, "NET_DVR_SET_HDGROUP_CFG"); 
		g_StringLanType(szLan, "ɹ,!", "Save parameter successfully, please reboot!");
		AfxMessageBox(szLan);
	}	
}

void CDlgHardDiskCfg::OnChkAllChan() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString csTmp;
	int iSel = 0;
	int iChanIndex = 0;
	int i = 0;

	for (i = 0; i<MAX_CHANNUM_V30; i++)
	{
		if (g_struDeviceInfo[m_dwDevIndex].struChanInfo[i].bEnable)
		{
			iSel++;
			m_listChan.SetCheck(iSel, m_bChkAllChan);
			iChanIndex = m_listChan.GetItemData(iSel);
			if (m_bChkAllChan)
			{
				m_struHDGroupCfg.struHDGroupAttr[m_iSelGroup].byHDGroupChans[iChanIndex] = 1;
			}
			else
			{
				m_struHDGroupCfg.struHDGroupAttr[m_iSelGroup].byHDGroupChans[iChanIndex] = 0;
			}
		}
	}

	UpdateData(FALSE);	
}

/*********************************************************
  Function:	
  Desc:		
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgHardDiskCfg::OnBtnHdSet() 
{
	// TODO: Add your control notification handler code here
	OnBnClickedBtnOneHdOk();
	char szLan[128] = {0};
	if (!NET_DVR_SetDVRConfig(m_lLoginID, NET_DVR_SET_HDCFG, 0, &m_struHDCfg, sizeof(NET_DVR_HDCFG)))
	{
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_FAIL_T, "NET_DVR_SET_HDCFG"); 
		g_StringLanType(szLan, "ʧ", "Save parameter failed");
		AfxMessageBox(szLan);
	}
	else
	{
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_SUCC_T, "NET_DVR_SET_HDCFG"); 
		g_StringLanType(szLan, "ɹ,!", "Save parameter successfully, please reboot!");
		AfxMessageBox(szLan);
	}
}
