#pragma once


class CDlgOutput : public CDialog
{
	DECLARE_DYNAMIC(CDlgOutput)

public:
	CDlgOutput(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgOutput();
	void CapturePicture();
	char m_szFileName[256];
	BOOL m_bCapture;
	//preview window index
	int m_iSubWndIndex;
	
	//window
	HWND m_hWnd;
	// save previewing channel info
	CHANNEL_INFO m_struChanInfo;
	// save previewing node
	HTREEITEM m_hChanItem;
	// delay buffer number
	int m_iNetDelayBufNum;
	// Open sound on preview
	BOOL m_bPlaySound;
	// preview handle
	LONG m_lPlayHandle;
	// preview window position
	CRect m_OutputRect;
	
	BOOL m_bLocalManualRec;//local manual record
	
	CString m_csDeviceIP;
	//cal when arrange the out put windows
	int m_iXPrecision;
	int m_iYPrecision;
	double m_xScale;
	double m_yScale;
	BOOL m_bPauseDecoder;
	HANDLE m_hCardHandle;
	BOOL m_bRestart;
	void Restart();
	NET_DVR_DISPLAY_PARA m_struCardPlayParam;//m_struCardPlayPara
	LONG m_lPort;// play port
	void StopLocalRecord();
	void StartLocalRecord();
	void ChangeRecordFileName();
	void ChangeCurWinCfg();
	time_t m_lChangeFileNameTime;
	
	//draw the yellow line on window edge
	void DrawOutputBorder(void);
	void CancelSelectZoom();

	// start preview
	LONG StartPlayInsideDecode(PCHANNEL_INFO pChanInfo,HTREEITEM hChanItem);

	LONG StartPlay(PCHANNEL_INFO pChanInfo,HTREEITEM hChanItem);
	// stop preview
	BOOL StopPlay(void);
	void AddLog(int iLogType, const char* format, ...);
	void StopSound();
	void StartSound(WORD wVolumeValue);
public:
	//{{AFX_DATA(CDlgOutput)
	enum { IDD = IDD_DLG_OUTPUT };
	//}}AFX_DATA


	//{{AFX_VIRTUAL(CDlgOutput)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
protected:
	// Generated message map functions
	//{{AFX_MSG(CDlgOutput)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	afx_msg void OnMenuNextPage();
	afx_msg void OnMenuFrontPage();
	afx_msg void  OnMenuPauseCycle();
	afx_msg void OnMenuSound();
	afx_msg void  OnMenuMultiScreenLarge();
	afx_msg void OnMenuStopPlay();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	
	DECLARE_MESSAGE_MAP()
};
