/**********************************************************
FileName:    DlgRemoteIPAccess.cpp
Description:       
Date:        2008/06/03
Note: 		<Global>struct, macro refer to GeneralDef.h, global variants and API refer to ClientDemo.cpp   
Modification History:      
    <version> <time>         <desc>
    <1.0    > <2008/06/03>       <created>
***********************************************************/

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgRemoteIPAccess.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgRemoteIPAccess dialog
/*********************************************************
  Function:	CDlgRemoteIPAccess
  Desc:		Constructor
  Input:	pParent, parent window pointer
  Output:	none
  Return:	none
**********************************************************/
CDlgRemoteIPAccess::CDlgRemoteIPAccess(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgRemoteIPAccess::IDD, pParent)
{
	m_dwDevIndex = 0;
	m_iCurSel = 0;
	m_iCurChanIndex = 0;
	m_bCurEnable = FALSE;
	m_bAnalogChange = FALSE;
	memset(&m_struIPParaCfg, 0, sizeof(NET_DVR_IPPARACFG));
	//{{AFX_DATA_INIT(CDlgRemoteIPAccess)
	m_csDevIP = _T("172.7.160.2");
	m_uDevPort = 8000;
	m_csDevPwd = _T("12345");
	m_ceDevUserName = _T("admin");
	m_iIPDevChan = 1;
	//}}AFX_DATA_INIT
}

/*********************************************************
  Function:	DoDataExchange
  Desc:		the map between control and variable
  Input:	pDX, CDataExchange,pass the data exchange object to the window CWnd::DoDataExchange
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgRemoteIPAccess)
	DDX_Control(pDX, IDC_LIST_IP_CHAN, m_listIPChan);
	DDX_Text(pDX, IDC_DEVICE_IP, m_csDevIP);
	DDX_Text(pDX, IDC_DEVICE_PORT, m_uDevPort);
	DDX_Text(pDX, IDC_DEVICE_PSW, m_csDevPwd);
	DDX_Text(pDX, IDC_DEVICE_USERNAME, m_ceDevUserName);
	DDX_Text(pDX, IDC_EDIT_CHAN, m_iIPDevChan);
	//}}AFX_DATA_MAP
}

/*********************************************************
  Function:	BEGIN_MESSAGE_MAP
  Desc:		the map between control and function
  Input:	first parameter:name of current class; second: name of base class
  Output:	none
  Return:	none
**********************************************************/
BEGIN_MESSAGE_MAP(CDlgRemoteIPAccess, CDialog)
	//{{AFX_MSG_MAP(CDlgRemoteIPAccess)
	ON_BN_CLICKED(IDC_BTN_ADD_IP_CHAN, OnBtnAddIPChan)
	ON_NOTIFY(NM_CLICK, IDC_LIST_IP_CHAN, OnClickListIPChan)
	ON_BN_CLICKED(IDC_BTN_DELETE, OnBtnDelete)
	ON_BN_CLICKED(IDC_BTN_ENABLE, OnBtnEnable)
	ON_BN_CLICKED(IDC_BTN_REFRESH, OnBtnRefresh)
	ON_BN_CLICKED(IDC_BTN_SAVE, OnBtnSave)
	ON_CBN_SELCHANGE(IDC_COMBO_ACCESS_TYPE, OnSelchangeComboAccessType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgRemoteIPAccess message handlers
/*********************************************************
  Function:	OnInitDialog
  Desc:		Initialize the dialog
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
BOOL CDlgRemoteIPAccess::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_listIPChan.SetExtendedStyle(m_listIPChan.GetExtendedStyle()|LVS_EX_FULLROWSELECT);
	char szLan[128] = {0};
	g_StringLanType(szLan, "", "Serial No.");
	m_listIPChan.InsertColumn(0, szLan,LVCFMT_LEFT,50,-1);
	g_StringLanType(szLan, "ͨ", "Channel");
	m_listIPChan.InsertColumn(1,szLan,LVCFMT_LEFT,80,-1);
	g_StringLanType(szLan, "IPַ", "IP Address");
	m_listIPChan.InsertColumn(2, szLan,LVCFMT_LEFT,100,-1);
	g_StringLanType(szLan, "˿ں", "Port");
	m_listIPChan.InsertColumn(3, szLan,LVCFMT_LEFT,120,-1);
	g_StringLanType(szLan, "IPͨ", "IP Channel");
	m_listIPChan.InsertColumn(4, szLan,LVCFMT_LEFT,100,-1);
	g_StringLanType(szLan, "Ƿ", "Whether online");
	m_listIPChan.InsertColumn(5, szLan,LVCFMT_LEFT,100,-1);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

/*********************************************************
  Function:	CheckInitParam
  Desc:		check and initialize the parameters
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::CheckInitParam()
{
	ShowWindow(SW_SHOW);
	int iDev = g_pMainDlg->GetCurDeviceIndex();
	if (iDev == -1 || g_pMainDlg->IsCurDevMatDec(iDev))
	{
		EnableWindow(FALSE);
		return;
	}

	EnableWindow(TRUE);
	m_dwDevIndex = iDev;
	m_dwStartChan = g_struDeviceInfo[m_dwDevIndex].iStartChan;
	m_iSelAccessType = 0;
	
	CString strTemp =_T("");
	CString strChanTmp = _T("");
	int i = 0;
	DWORD dwChanNum = 0;
	int iIndex = 0;
	DWORD dwIPChanIndex = 0;
	DWORD dwID = 0;
	m_iCurChanIndex = -1;
	m_iCurSel = -1;
	EnableInfoCtrl(FALSE);
	SetCtrlStat(2);
	HTREEITEM hChanItem = NULL;
	char szLan[128] = {0};
	m_listIPChan.DeleteAllItems();
	if (g_pMainDlg->DoGetDeviceResoureCfg(m_dwDevIndex))
	{
		g_pMainDlg->RedrawDeviceNode(m_dwDevIndex);

		memset(&m_struIPParaCfg, 0, sizeof(NET_DVR_IPPARACFG));
		memcpy(&m_struIPParaCfg, &g_struDeviceInfo[m_dwDevIndex].struIPParaCfg, sizeof(NET_DVR_IPPARACFG));
		for (i = 0; i < MAX_CHANNUM_V30; i++)
		{
			dwChanNum = i + g_struDeviceInfo[m_dwDevIndex].iStartChan;
			if (i < g_struDeviceInfo[m_dwDevIndex].iDeviceChanNum)
			{
				strTemp.Format("%02d", iIndex+1);
				m_listIPChan.InsertItem(iIndex, strTemp, 0);
				strTemp.Format(ANALOG_C_FORMAT, dwChanNum);
				m_listIPChan.SetItemText(iIndex, 1, strTemp);
				g_StringLanType(szLan, "", "local");
				m_listIPChan.SetItemText(iIndex, 2, szLan);
				m_listIPChan.SetItemText(iIndex, 3, "0");
				m_listIPChan.SetItemText(iIndex, 4, "0");
				if (m_struIPParaCfg.byAnalogChanEnable[i])
				{
					g_StringLanType(szLan, "", "Yes");
					m_listIPChan.SetItemText(i, 5, szLan);
					m_listIPChan.SetItemData(iIndex, ANALOG_CHAN_ENABLE*1000+i);
				}
				else
				{
					g_StringLanType(szLan, "", "No");
					m_listIPChan.SetItemText(i, 5, szLan);
					m_listIPChan.SetItemData(iIndex, ANALOG_CHAN_DISABLE*1000+i);
				}
				iIndex++;
			}
			else if (i >= g_struDeviceInfo[m_dwDevIndex].iDeviceChanNum && i < MAX_ANALOG_CHANNUM)
			{
			}
			else if (i >= MAX_ANALOG_CHANNUM  && i < (g_struDeviceInfo[m_dwDevIndex].iIPChanNum+MAX_ANALOG_CHANNUM))
			{
				dwIPChanIndex = i-MAX_ANALOG_CHANNUM;
				dwChanNum = dwIPChanIndex + g_struDeviceInfo[m_dwDevIndex].iStartChan;
				dwID = m_struIPParaCfg.struIPChanInfo[dwIPChanIndex].byIPID;
			
				strTemp.Format("%02d", iIndex+1);
				m_listIPChan.InsertItem(iIndex, strTemp, 0);

				strTemp.Format(IP_CAMERA_NAME, dwChanNum);
				m_listIPChan.SetItemText(iIndex, 1, strTemp);
				if (m_struIPParaCfg.struIPChanInfo[dwIPChanIndex].byIPID != 0)
				{
					m_listIPChan.SetItemText(iIndex, 2, m_struIPParaCfg.struIPDevInfo[dwID-1].struIP.sIpV4);
					strTemp.Format("%d", m_struIPParaCfg.struIPDevInfo[dwID-1].wDVRPort);
					m_listIPChan.SetItemText(iIndex, 3, strTemp);
					strTemp.Format("%d", m_struIPParaCfg.struIPChanInfo[dwIPChanIndex].byChannel);
					m_listIPChan.SetItemText(iIndex, 4, strTemp);
					if (m_struIPParaCfg.struIPChanInfo[dwIPChanIndex].byEnable)
					{
						g_StringLanType(szLan, "", "Online");
						m_listIPChan.SetItemText(iIndex, 5, szLan);	
					}		
					else
					{
						g_StringLanType(szLan, "", "Offline");
						m_listIPChan.SetItemText(iIndex, 5, szLan);
					}
					
					m_listIPChan.SetItemData(iIndex, IP_CHAN_ENABLE*1000+i);
				}
				else
				{
					m_listIPChan.SetItemText(iIndex, 2, "0.0.0.0");
					m_listIPChan.SetItemText(iIndex, 3, "0");
					m_listIPChan.SetItemText(iIndex, 4, "0");
					g_StringLanType(szLan, "", "No");
					m_listIPChan.SetItemText(iIndex, 5, szLan);
					m_listIPChan.SetItemData(iIndex, IP_CHAN_DISABLE*1000+i);
				}	
				iIndex++;
			}
		}	
		g_pMainDlg->DoGetIPAlarmInCfg(m_dwDevIndex);
		g_pMainDlg->DoGetIPAlarmOutCfg(m_dwDevIndex);
		GetDlgItem(IDC_BTN_SAVE)->EnableWindow(TRUE);
		EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_BTN_SAVE)->EnableWindow(FALSE);
		if (NET_DVR_GetLastError() == NET_DVR_NOSUPPORT)
		{
			EnableWindow(FALSE);
		}
	}
}

/*********************************************************
  Function:	OnBtnDelete
  Desc:		delete the ip carema
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::OnBtnDelete() 
{
	int i = 0;
	DWORD dwID = 0;
	CString csTmp = _T("0.0.0.0");
	BOOL bDeleteDev = TRUE;
	int iIPChan = m_iCurChanIndex-MAX_ANALOG_CHANNUM;//Current ip channel array index
	if (iIPChan < 0 && iIPChan >= MAX_IP_CHANNEL)
	{
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_FAIL_T, "chanindex[%d] err ip Channel", m_iCurChanIndex);
		return;
	}
	dwID = m_struIPParaCfg.struIPChanInfo[iIPChan].byIPID;
	if (dwID <= 0)
	{
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_FAIL_T, "the ip device error!");
		return;
	}
	for (i=0; i<MAX_IP_CHANNEL; i++)
	{
		if (iIPChan != i)
		{
			if (dwID == m_struIPParaCfg.struIPChanInfo[i].byIPID)
			{
				bDeleteDev = FALSE;//canot delete this IP device as it has been connected in other ip channel
				g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_SUCC_T, "other enable ip channel use the same ip device");
				break;
			}
		}
	}

	//ip豸Ϣ/clear current ip device 
	if (bDeleteDev)
	{
		memset(&(m_struIPParaCfg.struIPDevInfo[dwID-1]), 0, sizeof(NET_DVR_IPDEVINFO));
	}
	//յǰipͨϢ/clear current ip chan 
	memset(&(m_struIPParaCfg.struIPChanInfo[iIPChan]), 0, sizeof(NET_DVR_IPCHANINFO));

	m_listIPChan.SetItemText(m_iCurSel, 2, "0.0.0.0");
	m_listIPChan.SetItemText(m_iCurSel, 3, "0");
	m_listIPChan.SetItemText(m_iCurSel, 4, "0");
	char szLan[128] = {0};
	g_StringLanType(szLan, "", "No");
	m_listIPChan.SetItemText(m_iCurSel, 5, szLan);
	m_listIPChan.SetItemData(m_iCurSel, IP_CHAN_DISABLE*1000+m_iCurChanIndex);
	SetCtrlStat(IP_CHAN_DISABLE);
}

/*********************************************************
  Function:	OnBtnAddIPChan
  Desc:		add the ip camera
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::OnBtnAddIPChan() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int i = 0;
	int j = 0;
	DWORD dwID = 0;
	CString csTmp;
	BOOL bExistDev = FALSE;
	char szLan[128] = {0};
	int iIPChanIndex = m_iCurChanIndex-MAX_ANALOG_CHANNUM;
	if (iIPChanIndex < 0 && iIPChanIndex >= MAX_IP_CHANNEL)
	{
		g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_FAIL_T, "chan [%d] not ip Channel", m_iCurChanIndex);
		return;
	}
	if (m_iCurSel < 0)
	{		
		g_StringLanType(szLan, "ѡбеͨ", "Please choose the channel in the list");
		AfxMessageBox(szLan);
		return;
	}
	if (m_iIPDevChan == 0 || memcmp(m_csDevIP.GetBuffer(0), "0.0.0.0", m_csDevIP.GetLength()) == 0)
	{
		g_StringLanType(szLan, "", "Parameter error");
		AfxMessageBox(szLan);
		return;
	}	
	
	dwID = m_struIPParaCfg.struIPChanInfo[iIPChanIndex].byIPID;//current connetcted IP device ID
	if (dwID > 0)//this ip channel is connected to devices
	{
		for (j = 0; j < MAX_IP_CHANNEL; j++)
		{
			if (iIPChanIndex == j)
			{
				continue;
			}
			if (m_struIPParaCfg.struIPChanInfo[j].byIPID == dwID)
			{
				bExistDev = TRUE;
				break;
			}		
		}

		if (!bExistDev)
		{//this IP device is not connected in other IP channels, clear its device info
			memset(&(m_struIPParaCfg.struIPDevInfo[dwID-1]), 0, sizeof(NET_DVR_IPDEVINFO));
		}
	}
	//clear device info
	memset(&(m_struIPParaCfg.struIPChanInfo[iIPChanIndex]), 0, sizeof(NET_DVR_IPCHANINFO));

	bExistDev = FALSE;
	dwID = 0;

	for (i = 0; i<MAX_IP_DEVICE; i++)
	{
		//find existed device
		if (memcmp(m_csDevIP.GetBuffer(0), m_struIPParaCfg.struIPDevInfo[i].struIP.sIpV4, 16)== 0 && (m_uDevPort == m_struIPParaCfg.struIPDevInfo[i].wDVRPort) )
		{
			dwID = i+1;
			g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_SUCC_T, "dev[%d]ip[%s]exist", dwID, m_struIPParaCfg.struIPDevInfo[i].struIP.sIpV4);
			for (j = 0; j< MAX_IP_CHANNEL; j++)
			{
				if ((m_struIPParaCfg.struIPChanInfo[j].byIPID == dwID) && (m_iIPDevChan == m_struIPParaCfg.struIPChanInfo[j].byChannel))
				{
					g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_FAIL_T, "ipdev[%d]ip[%s]exist, chan[%d] had added", dwID, m_struIPParaCfg.struIPDevInfo[i].struIP.sIpV4, m_iIPDevChan);
					g_StringLanType(szLan, "ӦIP豸ͨѾ", "Corresponding IP device channel have been added");
					AfxMessageBox(szLan);
					return;
				}		
			}
			bExistDev = TRUE;
			g_pMainDlg->AddLog(m_dwDevIndex, OPERATION_SUCC_T, "ipdev[%d]ip[%s]existed and chan[%d] had not been added", dwID, m_struIPParaCfg.struIPDevInfo[i].struIP.sIpV4, m_iIPDevChan);
			break;
		}		
	}

	if (dwID == 0)//new device
	{
		for (i = 0; i< MAX_IP_DEVICE; i++)
		{
			if (!m_struIPParaCfg.struIPDevInfo[i].dwEnable)
			{
				dwID = i+1;//find the first empty node
				g_pMainDlg->AddLog(m_dwDevIndex, 3, "new ip[%s], ipdev[%d] is disable&can be use",m_csDevIP.GetBuffer(0),  dwID);
				break;
			}		
		}	
	}
	if (dwID == 0)
	{
		g_StringLanType(szLan, "ӵip豸Ŀ", "Exceeds the maximum number that can be added");
		AfxMessageBox(szLan);
		return;
	}
	m_struIPParaCfg.struIPChanInfo[iIPChanIndex].byEnable = FALSE;
	m_struIPParaCfg.struIPChanInfo[iIPChanIndex].byChannel = m_iIPDevChan;
	m_struIPParaCfg.struIPChanInfo[iIPChanIndex].byIPID = dwID;

	if (!bExistDev)
	{
		memcpy(m_struIPParaCfg.struIPDevInfo[dwID-1].struIP.sIpV4, m_csDevIP.GetBuffer(0), 16);
		m_struIPParaCfg.struIPDevInfo[dwID-1].dwEnable = TRUE;
		memcpy(m_struIPParaCfg.struIPDevInfo[dwID-1].sUserName, m_ceDevUserName.GetBuffer(0), NAME_LEN);
		memcpy(m_struIPParaCfg.struIPDevInfo[dwID-1].sPassword, m_csDevPwd.GetBuffer(0), PASSWD_LEN);
		m_struIPParaCfg.struIPDevInfo[dwID-1].wDVRPort = m_uDevPort;
	}

	m_listIPChan.SetItemText(m_iCurSel, 2, m_struIPParaCfg.struIPDevInfo[dwID-1].struIP.sIpV4);
	csTmp.Format("%d", m_struIPParaCfg.struIPDevInfo[dwID-1].wDVRPort);
	m_listIPChan.SetItemText(m_iCurSel, 3, csTmp);
	csTmp.Format("%d", m_struIPParaCfg.struIPChanInfo[iIPChanIndex].byChannel);
	m_listIPChan.SetItemText(m_iCurSel, 4, csTmp);
	g_StringLanType(szLan, "", "Yes");
	m_listIPChan.SetItemText(m_iCurSel, 5, szLan);
	m_listIPChan.SetItemData(m_iCurSel, IP_CHAN_ENABLE*1000+m_iCurChanIndex);
	SetCtrlStat(IP_CHAN_ENABLE);	
}

/*********************************************************
  Function:	OnClickListIPChan
  Desc:		choose the channel item in the list, and update the channel
  Input:	pNMHDR, Contains the click information
  Output:	pResult, result after handle notification	
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::OnClickListIPChan(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
 	POSITION  iPos = m_listIPChan.GetFirstSelectedItemPosition();
 	if (iPos == NULL)
 	{
 		return;
 	}
 	m_iCurSel = m_listIPChan.GetNextSelectedItem(iPos);
	int iData = m_listIPChan.GetItemData(m_iCurSel);
	m_iCurChanIndex = iData%1000;

	SetCtrlStat(iData/1000);
	UpdateData(FALSE);
	*pResult = 0;
}

/*********************************************************
  Function:	EnableInfoCtrl
  Desc:		enable the control status of the ip device
  Input:	bEnable, TRUE/FALSE; 
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::EnableInfoCtrl(BOOL bEnable)
{
	GetDlgItem(IDC_DEVICE_IP)->EnableWindow(bEnable);
	GetDlgItem(IDC_DEVICE_PORT)->EnableWindow(bEnable);
	GetDlgItem(IDC_DEVICE_PSW)->EnableWindow(bEnable);
	GetDlgItem(IDC_DEVICE_USERNAME)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_CHAN)->EnableWindow(bEnable);
}

/*********************************************************
  Function:	SetCtrlStat
  Desc:		change the button status as the type(analog or digital) of the channel
  Input:	iStat, the status of the channels
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::SetCtrlStat(int iStat)
{
	DWORD dwID = 0;
	char szLan[128] = {0};
	switch(iStat)
	{
	case ANALOG_CHAN_DISABLE://analog disable
		GetDlgItem(IDC_BTN_ADD_IP_CHAN)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_DELET)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_ENABLE)->EnableWindow(TRUE);
		g_StringLanType(szLan, "", "Enable");	
		GetDlgItem(IDC_BTN_ENABLE)->SetWindowText(szLan);
		EnableInfoCtrl(FALSE);
		m_bCurEnable = FALSE;
		break;
	case ANALOG_CHAN_ENABLE://analog enable channel
		GetDlgItem(IDC_BTN_ADD_IP_CHAN)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_DELET)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_ENABLE)->EnableWindow(TRUE);
		g_StringLanType(szLan, "", "Disable");	
		GetDlgItem(IDC_BTN_ENABLE)->SetWindowText(szLan);
		EnableInfoCtrl(FALSE);
		m_bCurEnable = TRUE;
		break;
	case IP_CHAN_DISABLE://digital disable channel
		GetDlgItem(IDC_BTN_ADD_IP_CHAN)->EnableWindow(TRUE);
		g_StringLanType(szLan, "", "Add");
		GetDlgItem(IDC_BTN_ADD_IP_CHAN)->SetWindowText(szLan);
		GetDlgItem(IDC_BTN_DELET)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_ENABLE)->EnableWindow(FALSE);
		//GetDlgItem(IDC_BTN_MOD)->EnableWindow(FALSE);
		EnableInfoCtrl(TRUE);
		m_bCurEnable = FALSE;
		break;
	case IP_CHAN_ENABLE://digital enable
		GetDlgItem(IDC_BTN_ADD_IP_CHAN)->EnableWindow(TRUE);
		g_StringLanType(szLan, "޸", "Modify");
		GetDlgItem(IDC_BTN_ADD_IP_CHAN)->SetWindowText(szLan);
		GetDlgItem(IDC_BTN_DELET)->EnableWindow(TRUE);
		GetDlgItem(IDC_BTN_ENABLE)->EnableWindow(FALSE);
		if (m_iCurChanIndex-MAX_ANALOG_CHANNUM)
		{
			dwID = m_struIPParaCfg.struIPChanInfo[m_iCurChanIndex-MAX_ANALOG_CHANNUM].byIPID;
			if (dwID > 0)
			{
				m_csDevIP.Format("%s", m_struIPParaCfg.struIPDevInfo[dwID-1].struIP.sIpV4);
			}
		}
		
		//GetDlgItem(IDC_BTN_MOD)->EnableWindow(TRUE);
		EnableInfoCtrl(TRUE);
		m_bCurEnable = TRUE;
		break;
	default:
	    break;
	}
	UpdateData(FALSE);
}

/*********************************************************
  Function:	OnBtnEnable
  Desc:		enable the analog channel or not
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::OnBtnEnable() 
{
	char szLan[128] = {0};
	if (m_bCurEnable)
	{
		g_StringLanType(szLan, "", "No");
		m_listIPChan.SetItemText(m_iCurSel, 5, szLan);
		m_listIPChan.SetItemData(m_iCurSel, ANALOG_CHAN_DISABLE*1000+m_iCurChanIndex);
		m_struIPParaCfg.byAnalogChanEnable[m_iCurChanIndex] = FALSE;
		SetCtrlStat(0);
	}
	else
	{
		g_StringLanType(szLan, "", "Yes");
		m_listIPChan.SetItemText(m_iCurSel, 5, szLan);
		m_listIPChan.SetItemData(m_iCurSel, ANALOG_CHAN_ENABLE*1000+m_iCurChanIndex);
		m_struIPParaCfg.byAnalogChanEnable[m_iCurChanIndex] = TRUE;
		SetCtrlStat(1);	
	}
	m_bAnalogChange = TRUE;
}

/*********************************************************
  Function:	OnBtnRefresh
  Desc:		get the ip configure again and refresh the local information
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::OnBtnRefresh() 
{
	// TODO: Add your control notification handler code here
	CheckInitParam();
}

/*********************************************************
  Function:	OnBtnSave
  Desc:		save the ip access configure
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::OnBtnSave() 
{
	char szLan[128] = {0};
	if (memcmp(g_struDeviceInfo[m_dwDevIndex].struIPParaCfg.byAnalogChanEnable, m_struIPParaCfg.byAnalogChanEnable, MAX_ANALOG_CHANNUM) != 0)
	{
		g_StringLanType(szLan, "޸ģͨʹ״̬,豸Զ!",\
			"Modify the status of Analog channel, the device will automatically restart");
		if (IDOK != MessageBox(szLan,"Warning",IDOK))
		{
			return;
		}
	}
	memcpy(&g_struDeviceInfo[m_dwDevIndex].struIPParaCfg, &m_struIPParaCfg, sizeof(NET_DVR_IPPARACFG));
	if (g_pMainDlg->DoSetIPAccessCfg(m_dwDevIndex))
	{
		g_StringLanType(szLan, "IPCóɹ!ˢ!", "IPC configuration settings successfully! Please refresh!");
		AfxMessageBox(szLan);
	}
	else
	{
		g_StringLanType(szLan, "IPCʧ!", "IPC configuration settings failed!");
		AfxMessageBox(szLan);
	}
}

/*********************************************************
  Function:	OnSelchangeComboAccessType
  Desc:		none
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgRemoteIPAccess::OnSelchangeComboAccessType() 
{
	// TODO: Add your control notification handler code here
	
}
