/**********************************************************
FileName:    DlgVoiceTalk.cpp
Description: Voice Talk      
Date:        2008/06/03
Note: 		<Global>struct, macro refer to GeneralDef.h, global variants and API refer to ClientDemo.cpp  
Modification History:      
    <version> <time>         <desc>
    <1.0    > <2008/06/03>       <created>
***********************************************************/

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgVoiceTalk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

FILE* fp1 = NULL;
FILE* fp2 = NULL;
void CALLBACK fAudioTalkDataCallBack(LONG lVoiceComHandle,char *pRecvDataBuffer,DWORD dwBufSize,BYTE byAudioFlag,void* pUser)
{
	if (!fp1)
	{
		fp1 = fopen("D:\\local.264","wb");
	}

	if (!fp2)
	{
		fp2 = fopen("D:\\device.264","wb");
	}
	
	if (byAudioFlag == 0)
	{
		fwrite(pRecvDataBuffer, 1, dwBufSize, fp1);
	}
	else if (byAudioFlag == 1)
	{
		fwrite(pRecvDataBuffer, 1, dwBufSize, fp2);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDlgVoiceTalk dialog
/*********************************************************
  Function:	OnInitDialog
  Desc:		Initialize the dialog
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
CDlgVoiceTalk::CDlgVoiceTalk(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgVoiceTalk::IDD, pParent)
{
	m_dwSel = 0;
	m_dwDeviceIndex = 0;
	//{{AFX_DATA_INIT(CDlgVoiceTalk)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

/*********************************************************
  Function:	DoDataExchange
  Desc:		the map between control and variable
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgVoiceTalk::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgVoiceTalk)
	DDX_Control(pDX, IDC_COMBO_DATA_TYPE, m_comboDataType);
	DDX_Control(pDX, IDC_COMBO_VOICE_CHAN, m_comboVoiceChan);
	//}}AFX_DATA_MAP
}

/*********************************************************
  Function:	BEGIN_MESSAGE_MAP
  Desc:		the map between control and function
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
BEGIN_MESSAGE_MAP(CDlgVoiceTalk, CDialog)
	//{{AFX_MSG_MAP(CDlgVoiceTalk)
	ON_BN_CLICKED(IDC_BTN_START, OnBtnStart)
	ON_BN_CLICKED(IDC_BTN_EXIT, OnBtnExit)
	ON_BN_CLICKED(IDC_BTN_STOP, OnBtnStop)
	ON_CBN_SELCHANGE(IDC_COMBO_VOICE_CHAN, OnSelchangeComboVoiceChan)
	ON_BN_CLICKED(IDC_BTN_REFRESH, OnBtnRefresh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgVoiceTalk message handlers
/*********************************************************
  Function:	OnInitDialog
  Desc:		Initialize the dialog
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
BOOL CDlgVoiceTalk::OnInitDialog()
{
	CDialog::OnInitDialog();
	EnableCtrl();
	char szLan[128] = {0};
	m_comboVoiceChan.ResetContent();
	switch (g_struDeviceInfo[m_dwDeviceIndex].iAudioNum)
	{
	case 1:
		m_comboVoiceChan.AddString("Audio1");
		break;
	case 2:
		m_comboVoiceChan.AddString("Audio1");
		m_comboVoiceChan.AddString("Audio2");
		break;
	default:
		break;
	}
	m_comboVoiceChan.SetCurSel(0);
	m_comboDataType.SetCurSel(0);
	
	memset(&m_struWorkState, 0, sizeof(NET_DVR_WORKSTATE_V30));
	if (!NET_DVR_GetDVRWorkState_V30(g_struDeviceInfo[m_dwDeviceIndex].lLoginID, &m_struWorkState))
	{
		g_pMainDlg->AddLog(m_dwDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GetDVRWorkState_V30 before Voice Talk");
		GetDlgItem(IDC_STATIC_STATUS)->ShowWindow(SW_HIDE);
	}
	else
	{

		if (0 == m_struWorkState.byAudioChanStatus[m_dwSel])
		{
			GetDlgItem(IDC_STATIC_STATUS)->ShowWindow(SW_SHOW);
			g_StringLanType(szLan, "״̬:δʹ", "Status: Unused");
			GetDlgItem(IDC_STATIC_STATUS)->SetWindowText(szLan);
		}
		else if (1 == m_struWorkState.byAudioChanStatus[m_dwSel])
		{
			GetDlgItem(IDC_STATIC_STATUS)->ShowWindow(SW_SHOW);
			g_StringLanType(szLan, "״̬:ʹ", "Status: Used");
			GetDlgItem(IDC_STATIC_STATUS)->SetWindowText(szLan);
		}
		else if (0xff == m_struWorkState.byAudioChanStatus[m_dwSel])
		{
			GetDlgItem(IDC_STATIC_STATUS)->ShowWindow(SW_HIDE);
		}
	}
	return TRUE;
}

/*********************************************************
  Function:	OnBtnStart
  Desc:		start to voice talk
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgVoiceTalk::OnBtnStart() 
{
	UpdateData(TRUE);
	char szLan[128] = {0};

	g_lVoiceHandle = NET_DVR_StartVoiceCom_V30(g_struDeviceInfo[m_dwDeviceIndex].lLoginID, m_dwSel+1, m_comboDataType.GetCurSel(), fAudioTalkDataCallBack, /*NULL,*/ NULL);//fVoiceDataCallBack
	if (g_lVoiceHandle == -1)
	{
		g_pMainDlg->AddLog(m_dwDeviceIndex, OPERATION_FAIL_T, "NET_DVR_StartVoiceCom_V30 audio index[%d]", m_dwSel);
		g_StringLanType(szLan, "Խʧ", "Voice talk failed");
		AfxMessageBox(szLan);	
	}
	else
	{
		g_pMainDlg->AddLog(m_dwDeviceIndex, OPERATION_SUCC_T, "NET_DVR_StartVoiceCom_V30 audio[%d]", m_dwSel);
	}
	EnableCtrl();
}

/*********************************************************
  Function:	OnBtnExit
  Desc:		exit the dialog
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgVoiceTalk::OnBtnExit() 
{
	// TODO: Add your control notification handler code here
	CDlgVoiceTalk::OnCancel();
}

/*********************************************************
  Function:	OnBtnStop
  Desc:		stop voice talk
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgVoiceTalk::OnBtnStop() 
{
	char szLan[128] = {0};
	if (g_lVoiceHandle >= 0)
	{
		if (NET_DVR_StopVoiceCom(g_lVoiceHandle))
		{
			g_pMainDlg->AddLog(m_dwDeviceIndex, OPERATION_SUCC_T, "NET_DVR_StopVoiceCom handle[%d]", g_lVoiceHandle);
			g_lVoiceHandle = -1;
		}
		else
		{
			g_pMainDlg->AddLog(m_dwDeviceIndex, OPERATION_FAIL_T, "NET_DVR_StopVoiceCom handle[%d]", g_lVoiceHandle);
			g_StringLanType(szLan, "رնԽʧ", "Close Voice Talk failed");
			AfxMessageBox(szLan);	
		} 
	}
	EnableCtrl();	
}

/*********************************************************
  Function:	OnSelchangeComboVoiceChan
  Desc:		лͨ,¶ӦĶԽ״̬
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgVoiceTalk::OnSelchangeComboVoiceChan() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_dwSel = m_comboVoiceChan.GetCurSel();
	char szLan[128] = {0};
	if (0 == m_struWorkState.byAudioChanStatus[m_dwSel])
	{
		GetDlgItem(IDC_STATIC_STATUS)->ShowWindow(SW_SHOW);
		g_StringLanType(szLan, "״̬:δʹ", "Status: Unused");
		GetDlgItem(IDC_STATIC_STATUS)->SetWindowText(szLan);
	}
	else if (1 == m_struWorkState.byAudioChanStatus[m_dwSel])
	{
		GetDlgItem(IDC_STATIC_STATUS)->ShowWindow(SW_SHOW);
		g_StringLanType(szLan, "״̬:ʹ", "Status: Used");
		GetDlgItem(IDC_STATIC_STATUS)->SetWindowText(szLan);
	}
	else if (0xff == m_struWorkState.byAudioChanStatus[m_dwSel])
	{
		GetDlgItem(IDC_STATIC_STATUS)->ShowWindow(SW_HIDE);
	}
}

/*********************************************************
  Function:	EnableCtrl
  Desc:		update the control status
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgVoiceTalk::EnableCtrl()
{
	BOOL bVoiceTalk = FALSE;
	char szLan[128] = {0};
	if (g_lVoiceHandle>=0)
	{
		bVoiceTalk = TRUE;
		g_StringLanType(szLan, "״̬:ʹ", "Status: Used");
		GetDlgItem(IDC_STATIC_STATUS)->SetWindowText(szLan);
	}
	else
	{
		bVoiceTalk = FALSE;
		g_StringLanType(szLan, "״̬:δʹ", "Status: Unused");
		GetDlgItem(IDC_STATIC_STATUS)->SetWindowText(szLan);
	}
	GetDlgItem(IDC_BTN_STOP)->EnableWindow(bVoiceTalk);
	GetDlgItem(IDC_BTN_START)->EnableWindow(!bVoiceTalk);
	GetDlgItem(IDC_COMBO_VOICE_CHAN)->EnableWindow(!bVoiceTalk);
}

void CDlgVoiceTalk::OnBtnRefresh() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	memset(&m_struWorkState, 0, sizeof(NET_DVR_WORKSTATE_V30));
	if (!NET_DVR_GetDVRWorkState_V30(g_struDeviceInfo[m_dwDeviceIndex].lLoginID, &m_struWorkState))
	{
		g_pMainDlg->AddLog(m_dwDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GetDVRWorkState_V30 before Talk MR");
		GetDlgItem(IDC_STATIC_STATUS)->ShowWindow(SW_HIDE);
	}

	OnSelchangeComboVoiceChan();
}
