/**********************************************************
FileName:    SubDlgChanCfg.cpp
Description: Channel Configuration      
Date:        2008/05/17
Note: 		<Global>struct, macro refer to GeneralDef.h, global variants and API refer to ClientDemo.cpp  
Modification History:      
    <version> <time>         <desc>
    <1.0    > <2008/05/17>       <created>
***********************************************************/


#include "stdafx.h"
#include "ClientDemo.h"
#include "SubDlgChanCfg.h"
#include "DlgRemoteRecordSchedule.h"
#include "DlgRemoteHideArea.h"
#include "DlgRemoteMotionDetect.h"
#include "DlgRemoteHideAlarm.h"
#include "DlgRemoteVideoInLost.h"
#include "DlgRemoteShowString.h"
#include ".\subdlgchancfg.h"

LPNET_DVR_MOTION_V30 g_lpMotionDetect = NULL;
LPNET_DVR_HIDEALARM_V30 g_lpHideAlarm = NULL;
LPNET_DVR_VILOST_V30 g_lpVILost = NULL;
// CSubDlgChanCfg dialog

/*********************************************************
  Function:	CSubDlgChanCfg
  Desc:		Constructor
  Input:	
  Output:	
  Return:	
**********************************************************/
IMPLEMENT_DYNAMIC(CSubDlgChanCfg, CDialog)
CSubDlgChanCfg::CSubDlgChanCfg(CWnd* pParent /*=NULL*/)
	: CDialog(CSubDlgChanCfg::IDD, pParent)
	, m_csChanName(_T(""))
	, m_iBitRate(0)
	, m_iFrameIInterval(0)
	, m_bCheckRecord(FALSE)
	, m_bCheckHideArea(FALSE)
	, m_bCheckMotion(FALSE)
	, m_bCheckHideAlarm(FALSE)
	, m_bCheckVILost(FALSE)
	, m_bCheckOsd(FALSE)
	, m_iOsdX(0)
	, m_iOsdY(0)
	, m_bChkDispWeek(FALSE)
	, m_bCheckChanName(FALSE)
	, m_iChanNameX(0)
	, m_iChanNameY(0)
	, m_iDeviceIndex(-1)
	, m_lLoginID(-1)
	, m_iCompressionTypeSel(NORM_HIGH_STREAM_COMPRESSION)
	, m_iCurChanIndex(-1)
	, m_iChanShowNum(0)
	, m_iCopyChanIndex(0)
	, m_iChanCount(0)
	, m_lStartChannel(0)
	, m_dwAlarmOutNum(0)
	, m_dwDurationTime(0)
{
	for (int i=0; i<MAX_CHANNUM_V30; i++)
	{
		m_bSetChannelPara[i] = FALSE;
		m_bGetChannelPara[i] = FALSE;
		m_bRemoteRecord[i] = FALSE;
	}
	memset(&m_struPicCfg[0], 0, MAX_CHANNUM_V30*sizeof(NET_DVR_PICCFG_V30));
	memset(&m_struCompressionCfg[0], 0, MAX_CHANNUM_V30*sizeof(NET_DVR_COMPRESSIONCFG_V30));
	memset(&m_struRemoteRecCfg[0], 0, MAX_CHANNUM_V30*sizeof(NET_DVR_RECORD_V30));
}

/*********************************************************
  Function:	~CSubDlgChanCfg
  Desc:		destructor
  Input:	
  Output:	
  Return:	
**********************************************************/
CSubDlgChanCfg::~CSubDlgChanCfg()
{
}

/*********************************************************
Function:	DoDataExchange
Desc:		the map between control and variable
Input:	
Output:	
Return:	
**********************************************************/
void CSubDlgChanCfg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSubDlgChanCfg)
	DDX_Control(pDX, IDC_COMBO_HOUR_TYPE, m_comboHourType);
	DDX_Control(pDX, IDC_COMBO_VIDEO_TYPE, m_comboVideoType);
	DDX_Control(pDX, IDC_COMBO_AUDIO_TYPE, m_comboAudioType);
	DDX_Control(pDX, IDC_COMBO_COMPRESSION_TYPE, m_comboCompressionType);
	DDX_Check(pDX, IDC_CHK_HIDE_ALARM, m_bCheckHideAlarm);
	DDX_Check(pDX, IDC_CHK_VILOST, m_bCheckVILost);
	DDX_Check(pDX, IDC_CHK_MOTION, m_bCheckMotion);
	DDX_Control(pDX, IDC_EDIT_REC_DELAY, m_comboRecDelay);
	DDX_Control(pDX, IDC_EDIT_PRERECORD_TIME, m_comboPreRecordTime);
	DDX_Check(pDX, IDC_CHK_HIDE_AREA, m_bCheckHideArea);
	DDX_Control(pDX, IDC_COMBO_CHAN, m_comboChanNum);
	DDX_Text(pDX, IDC_EDIT_CHANNEL_NAME, m_csChanName);
	DDX_Control(pDX, IDC_COMBO_IMAGE_QUALITY, m_comboImageQuality);
	DDX_Control(pDX, IDC_COMBO_STREAM_TYPE, m_comboStreamType);
	DDX_Control(pDX, IDC_COMBO_RESOLUTION, m_comboResolution);
	DDX_Control(pDX, IDC_COMBO_BIT_RATE_TYPE, m_comboBitRateType);
	DDX_Control(pDX, IDC_COMBO_FRAME_RATE, m_comboFrameRate);
	DDX_Control(pDX, IDC_COMBO_MAX_BIT_RATE, m_comboBitRate);
	DDX_Text(pDX, IDC_EDIT_BIT_RATE, m_iBitRate);
	DDX_Text(pDX, IDC_EDIT_FRAME_I_INTERVAL, m_iFrameIInterval);
	DDX_Control(pDX, IDC_COMBO_FRAME_BP_INTERVAL, m_comboFrameBPInterval);
	DDX_Check(pDX, IDC_CHK_RECORD, m_bCheckRecord);
	DDX_Check(pDX, IDC_CHK_OSD, m_bCheckOsd);
	DDX_Text(pDX, IDC_EDIT_OSD_X, m_iOsdX);
	DDX_Text(pDX, IDC_EDIT_OSD_Y, m_iOsdY);
	DDX_Check(pDX, IDC_CHK_DISPLAY_WEEK, m_bChkDispWeek);
	DDX_Control(pDX, IDC_COMBO_OSD_ATTRIB, m_comboOsdAttrib);
	DDX_Control(pDX, IDC_COMBO_OSD_TYPE, m_comboOsdType);
	DDX_Check(pDX, IDC_CHK_CHAN_NAME, m_bCheckChanName);
	DDX_Text(pDX, IDC_EDIT_CHAN_NAME_X, m_iChanNameX);
	DDX_Text(pDX, IDC_EDIT_CHAN_NAME_Y, m_iChanNameY);
	DDX_Control(pDX, IDC_COMBO_COPY_CHAN, m_comboCopyChan);
	DDX_Text(pDX, IDC_EDIT_DURATION_TIME, m_dwDurationTime);
	DDX_Check(pDX, IDC_CHK_REDUNDANCY_REC, m_bChkRedundancyRec);
	DDX_Check(pDX, IDC_CHK_AUDIO_REC, m_bChkAudioRec);
	//}}AFX_DATA_MAP
}

/*********************************************************
Function:	BEGIN_MESSAGE_MAP
Desc:		the map between control and function
Input:	
Output:	
Return:	
**********************************************************/
BEGIN_MESSAGE_MAP(CSubDlgChanCfg, CDialog)
	//{{AFX_MSG_MAP(CSubDlgChanCfg)	
	ON_CBN_SELCHANGE(IDC_COMBO_MAX_BIT_RATE, OnCbnSelchangeComboMaxBitRate)
	ON_CBN_SELCHANGE(IDC_COMBO_COMPRESSION_TYPE, OnCbnSelchangeComboCompressionType)
	ON_BN_CLICKED(IDC_BTN_CMP_OK, OnBnClickedBtnCmpOk)
	ON_BN_CLICKED(IDC_BTN_REMOTE_RECORD_SETUP, OnBnClickedBtnRemoteRecordSetup)
	ON_BN_CLICKED(IDC_BTN_HIDE_SETUP, OnBnClickedBtnHideSetup)
	ON_BN_CLICKED(IDC_BTN_MOTION_SETUP, OnBnClickedBtnMotionSetup)
	ON_BN_CLICKED(IDC_BTN_HIDE_ALARM_SETUP, OnBnClickedBtnHideAlarmSetup)
	ON_BN_CLICKED(IDC_BTN_VILOST_SETUP, OnBnClickedBtnVilostSetup)
	ON_BN_CLICKED(IDC_BTN_STRING, OnBnClickedBtnString)
	ON_BN_CLICKED(IDC_BTN_CHAN_COPY, OnBnClickedBtnChanCopy)
	ON_BN_CLICKED(ID_BTN_CHAN_CFG_OK, OnBnClickedBtnChanCfgOk)
	ON_BN_CLICKED(ID_BTN_CHAN_CFG_EXIT, OnBnClickedBtnChanCfgExit)
	ON_BN_CLICKED(IDC_CHK_RECORD, OnBnClickedChkRecord)
	ON_BN_CLICKED(IDC_CHK_HIDE_AREA, OnBnClickedChkHideArea)
	ON_BN_CLICKED(IDC_CHK_OSD, OnBnClickedChkOsd)
	ON_BN_CLICKED(IDC_CHK_CHAN_NAME, OnBnClickedChkChanNamePos)
	ON_CBN_SELCHANGE(IDC_COMBO_CHAN, OnCbnSelchangeComboChan)
	ON_CBN_SELCHANGE(IDC_COMBO_COPY_CHAN, OnCbnSelchangeComboCopyChan)
	ON_BN_CLICKED(IDC_CHK_MOTION, OnBnClickedChkMotion)
	ON_BN_CLICKED(IDC_CHK_HIDE_ALARM, OnBnClickedChkHideAlarm)
	ON_BN_CLICKED(IDC_CHK_VILOST, OnBnClickedChkVilost)
	ON_CBN_SELCHANGE(IDC_COMBO_FRAME_RATE, OnCbnSelchangeComboFrameRate)
//	ON_CBN_SELCHANGE(IDC_COMBO_BIT_RATE_TYPE, OnCbnSelchangeComboBitRateType)
	//}}AFX_MSG_MAP	
END_MESSAGE_MAP()

// CSubDlgChanCfg message handlers

/*********************************************************
Function:	OnInitDialog
Desc:		Initialize the dialog
Input:	
Output:	
Return:	
**********************************************************/
BOOL CSubDlgChanCfg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CRect rc(0, 0, 0, 0);
	GetParent()->GetClientRect(&rc);
	((CTabCtrl*)GetParent())->AdjustRect(FALSE, &rc);
	MoveWindow(&rc);

	return TRUE; 
}

/*********************************************************
Function:	CheckInitParam
Desc:		Check and update init paramerters
Input:	
Output:	
Return:	TRUE,device parameters correct, init device;FALSE,do not init
**********************************************************/
BOOL CSubDlgChanCfg::CheckInitParam()
{
	int iDeviceIndex = g_pMainDlg->GetCurDeviceIndex();

	if (iDeviceIndex == -1)
	{
		return FALSE;
	}
	
	if (g_pMainDlg->IsCurDevMatDec(iDeviceIndex))
	{
		return FALSE;
	}

	if (m_iDeviceIndex == iDeviceIndex && m_iCurChanIndex != -1)
	{
		return TRUE;
	}
	else
	{
		m_iDeviceIndex = iDeviceIndex;
		m_lLoginID = g_struDeviceInfo[m_iDeviceIndex].lLoginID;
		m_lStartChannel = g_struDeviceInfo[m_iDeviceIndex].iStartChan;
		m_iChanCount = g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum;
		m_dwAlarmOutNum = g_struDeviceInfo[m_iDeviceIndex].iAlarmOutNum;
	}


	m_bCheckHideAlarm = FALSE;
	m_bCheckVILost = FALSE;
	m_bCheckMotion = FALSE;

	m_bCheckHideArea = FALSE;
	m_csChanName = _T("");

	m_iBitRate = 0;
	m_iFrameIInterval = 0;
	m_comboRecDelay.SetCurSel(-1);
	m_comboPreRecordTime.SetCurSel(-1);
	m_comboChanNum.SetCurSel(-1);
	m_comboImageQuality.SetCurSel(-1);
	m_comboStreamType.SetCurSel(-1);
	m_comboResolution.SetCurSel(-1);
	m_comboBitRateType.SetCurSel(-1);
	m_comboFrameRate.SetCurSel(-1);
	m_comboBitRate.SetCurSel(-1);
	m_comboFrameBPInterval.SetCurSel(-1);

	m_comboOsdAttrib.SetCurSel(-1);
	m_comboOsdType.SetCurSel(-1);
	m_comboHourType.SetCurSel(-1);
	m_bCheckRecord = FALSE;
	m_bCheckOsd = FALSE;
	m_iOsdX = 0;
	m_iOsdY = 0;
	m_bChkDispWeek = FALSE;
	m_bCheckChanName = FALSE;
	m_iChanNameX = 0;
	m_iChanNameY = 0;
	m_iCompressionTypeSel = 0;
	m_comboCopyChan.ResetContent();
	m_comboChanNum.ResetContent();

	if (m_lLoginID < 0)
	{
		return FALSE;
	}

	DWORD dwReturned = 0;
	int i=0;
	CString sTemp;
	DWORD dwChanShow = 0;//display channel number
	DWORD iCopyIndex = 0;
	char szLan[128] = {0};
	m_iCopyChanIndex = -1;
	
	m_comboCompressionType.ResetContent();
	g_StringLanType(szLan, "¼()", "Record(Major Stream)");
	m_comboCompressionType.AddString(szLan);
	g_StringLanType(szLan, "()", "Net(Minor Stream)");
	m_comboCompressionType.AddString(szLan);
	g_StringLanType(szLan, "¼", "Event");
	m_comboCompressionType.AddString(szLan);
	
	//2008-9-6 12:54
	//m_comboCompressionType.AddString("Чѹ(¼)");	
	m_comboCompressionType.SetCurSel(0);
	g_StringLanType(szLan, "ȫͨ", "All Channels");
	m_comboCopyChan.AddString(szLan);
	for (i=0; i<MAX_CHANNUM_V30; i++)
	{
		dwChanShow = m_lStartChannel+i;

		m_bSetChannelPara[i] = FALSE;
		m_bGetChannelPara[i] = FALSE;
		m_bRemoteRecord[i] = FALSE;
		if (i<MAX_ANALOG_CHANNUM)//g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum
		{
			sTemp.Format(ANALOG_C_FORMAT, dwChanShow);
		}
		else if(i>=MAX_ANALOG_CHANNUM)
		{
			sTemp.Format(DIGITAL_C_FORMAT, dwChanShow-MAX_ANALOG_CHANNUM);
		}
		m_comboChanNum.AddString(sTemp);
		if (g_struDeviceInfo[m_iDeviceIndex].struChanInfo[i].bEnable)
		{
			memset(&m_struCompressionCfg[i], 0, sizeof(m_struCompressionCfg[i]));
			if (!NET_DVR_GetDVRConfig(m_lLoginID, NET_DVR_GET_COMPRESSCFG_V30, dwChanShow,&m_struCompressionCfg[i], sizeof(NET_DVR_COMPRESSIONCFG_V30), &dwReturned))
			{
				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "chan[%d] NET_DVR_GET_COMPRESSCFG_V30", dwChanShow);
				//return FALSE;
			}
// 			else
// 			{
// 				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GET_COMPRESSCFG_V30 chan[%d]", dwChanShow);	
// 			}
			
			memset(&m_struPicCfg[i], 0, sizeof(m_struPicCfg[i]));
			if (!NET_DVR_GetDVRConfig(m_lLoginID, NET_DVR_GET_PICCFG_V30, dwChanShow, &m_struPicCfg[i], sizeof(NET_DVR_PICCFG_V30), &dwReturned))
			{
				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "chan[%d]:NET_DVR_GET_PICCFG_V30", dwChanShow);
				//return FALSE;
			}
// 			else
// 			{
// 				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GET_PICCFG_V30 chan[%d]", dwChanShow);	
// 			}
			
			memset(&m_struRemoteRecCfg[i], 0, sizeof(m_struRemoteRecCfg[i]));
			if (!NET_DVR_GetDVRConfig(m_lLoginID,NET_DVR_GET_RECORDCFG_V30, dwChanShow, &m_struRemoteRecCfg[i], sizeof(NET_DVR_RECORD_V30), &dwReturned))	
			{
				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "chan[%d] NET_DVR_GET_RECORDCFG_V30", dwChanShow);	
				//return FALSE;
			}
// 			else
// 			{
// 				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GET_RECORDCFG_V30 chan[%d]", dwChanShow);	
// 			}

			m_comboCopyChan.AddString(sTemp);
			m_comboCopyChan.SetItemData(iCopyIndex, i);	
			iCopyIndex++;//0 map to all channels
			m_bGetChannelPara[i] = TRUE;
		}
		else 
		{
			continue;
		}
	}
	g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GET_CFG");	
	return TRUE;
}

/*********************************************************
Function:	CurCfgUpdate
Desc:		Update device parameters and refreshthecontrols
Input:	
Output:	
Return:	
**********************************************************/
void CSubDlgChanCfg::CurCfgUpdate(int iChanIndex)
{ 
	//Validate in the main dialog box
	//if (!CheckInitParam())
	//{
	//	
	//	EnableWindow(FALSE);
	//	return;
	//}
	//EnableWindow(TRUE);
	
	char cTemp[100] = {0};
	int i = 0;

	if (iChanIndex == -1)
	{//channel index may be -1 and select a node on the device list, the default value is set as the first valid index value
		for (i=0; i<MAX_CHANNUM_V30; i++)
		{
			if (g_struDeviceInfo[m_iDeviceIndex].struChanInfo[i].bEnable)
			{
				break;
			}
		}
		m_iCurChanIndex = i;
	}
	else
	{
		m_iCurChanIndex = iChanIndex;
	}

	if (m_iCurChanIndex < MAX_ANALOG_CHANNUM)
	{
		GetDlgItem(IDC_BTN_STRING)->EnableWindow(TRUE);	
	}
	else
	{
		GetDlgItem(IDC_BTN_STRING)->EnableWindow(FALSE);
	}

	m_comboChanNum.SetCurSel(m_iCurChanIndex);
	m_comboCopyChan.SetCurSel(0);
	m_iChanShowNum = m_iCurChanIndex+m_lStartChannel;

	//compression parameters
	UpdateCompressionInfo();
	
	//recording paramerters
	m_bCheckRecord = m_struRemoteRecCfg[m_iCurChanIndex].dwRecord;
	GetDlgItem(IDC_BTN_REMOTE_RECORD_SETUP)->EnableWindow(m_bCheckRecord);
	m_comboRecDelay.SetCurSel(m_struRemoteRecCfg[m_iCurChanIndex].dwRecordTime);
	m_comboPreRecordTime.SetCurSel(m_struRemoteRecCfg[m_iCurChanIndex].dwPreRecordTime);
	if (0xffffffff == m_struRemoteRecCfg[m_iCurChanIndex].dwRecorderDuration)
	{
		GetDlgItem(IDC_EDIT_DURATION_TIME)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_EDIT_DURATION_TIME)->EnableWindow(TRUE);
		m_dwDurationTime = m_struRemoteRecCfg[m_iCurChanIndex].dwRecorderDuration;
	}

	if (0xff == m_struRemoteRecCfg[m_iCurChanIndex].byRedundancyRec)
	{
		GetDlgItem(IDC_CHK_REDUNDANCY_REC)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_CHK_REDUNDANCY_REC)->EnableWindow(TRUE);
		m_bChkRedundancyRec = m_struRemoteRecCfg[m_iCurChanIndex].byRedundancyRec;
	}

	if (0xff == m_struRemoteRecCfg[m_iCurChanIndex].byAudioRec)
	{
		GetDlgItem(IDC_CHK_AUDIO_REC)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_CHK_AUDIO_REC)->EnableWindow(TRUE);
		m_bChkAudioRec = m_struRemoteRecCfg[m_iCurChanIndex].byAudioRec;
	}

	//image parameters
	ZeroMemory(cTemp, 100);
	memcpy(cTemp, m_struPicCfg[m_iCurChanIndex].sChanName, NAME_LEN);
	m_csChanName.Format("%s",cTemp);
	m_bCheckHideArea = m_struPicCfg[m_iCurChanIndex].dwEnableHide;
	GetDlgItem(IDC_BTN_HIDE_SETUP)->EnableWindow(m_bCheckHideArea);
	m_bCheckMotion = m_struPicCfg[m_iCurChanIndex].struMotion.byEnableHandleMotion;
	GetDlgItem(IDC_BTN_MOTION_SETUP)->EnableWindow(m_bCheckMotion);
	if (m_struPicCfg[m_iCurChanIndex].struHideAlarm.dwEnableHideAlarm > 0)
	{
		m_bCheckHideAlarm = TRUE;
	}
	else
	{
		m_bCheckHideAlarm = FALSE;
	}
	GetDlgItem(IDC_BTN_HIDE_ALARM_SETUP)->EnableWindow(m_bCheckHideAlarm);

	m_bCheckChanName = m_struPicCfg[m_iCurChanIndex].dwShowChanName;
	EnableChanname(m_bCheckChanName);
	m_iChanNameX = m_struPicCfg[m_iCurChanIndex].wShowNameTopLeftX;
	m_iChanNameY = m_struPicCfg[m_iCurChanIndex].wShowNameTopLeftY;
	m_bCheckOsd = m_struPicCfg[m_iCurChanIndex].dwShowOsd;
	EnableOsd(m_bCheckOsd);
	m_iOsdX = m_struPicCfg[m_iCurChanIndex].wOSDTopLeftX;
	m_iOsdY = m_struPicCfg[m_iCurChanIndex].wOSDTopLeftY;
	m_bChkDispWeek = m_struPicCfg[m_iCurChanIndex].byDispWeek;
	m_comboOsdAttrib.SetCurSel(m_struPicCfg[m_iCurChanIndex].byOSDAttrib-1);
	m_comboOsdType.SetCurSel(m_struPicCfg[m_iCurChanIndex].byOSDType);
	m_comboHourType.SetCurSel(m_struPicCfg[m_iCurChanIndex].byHourOSDType);
	m_bCheckVILost = m_struPicCfg[m_iCurChanIndex].struVILost.byEnableHandleVILost;
	GetDlgItem(IDC_BTN_VILOST_SETUP)->EnableWindow(m_bCheckVILost);
// 	m_bChkAuLost = m_struPicCfg[m_iCurChanIndex].struAULost.byEnableHandleVILost;
// 	GetDlgItem(IDC_BTN_AULOST_SETUP)->EnableWindow(m_bChkAuLost);
	GetDlgItem(ID_BTN_CHAN_CFG_OK)->EnableWindow(TRUE);

	UpdateData(FALSE);
}

/*********************************************************
  Function:	OnCbnSelchangeComboChan
  Desc:		get channel paramerets and refresh the control
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnCbnSelchangeComboChan()
{
	UpdateData(TRUE);
	int iChanIndex  = m_comboChanNum.GetCurSel();
	CurCfgUpdate(iChanIndex);
}

/*********************************************************
  Function:	OnBnClickedBtnRemoteRecordSetup
  Desc:		remote recording schedule
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnRemoteRecordSetup()
{
	CDlgRemoteRecordSchedule dlg;

	dlg.m_struRemoteRecSchedule = &(m_struRemoteRecCfg[m_iCurChanIndex]);
	if (dlg.DoModal() == IDOK)
	{
		m_bSetChannelPara[m_iCurChanIndex] = TRUE;
		g_bMustReboot = g_pMainDlg->IsNeedRebootDevType();
	}
}


/*********************************************************
  Function:	OnBnClickedBtnHideSetup
  Desc:		privacy mask setting
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnHideSetup()
{
	CDlgRemoteHideArea dlg;
	int i = 0;

	for (i=0; i<MAX_SHELTERNUM; i++)
	{
		memcpy(&(dlg.m_struShelter[i]), &(m_struPicCfg[m_iCurChanIndex].struShelter[i]),sizeof(NET_DVR_SHELTER));
	}
	dlg.m_iChanShowNum = m_iChanShowNum;
	dlg.m_lLoginID = m_lLoginID;
	if (dlg.DoModal() == IDOK)
	{
		for (i=0; i<MAX_SHELTERNUM; i++)
		{
			memcpy(&(m_struPicCfg[m_iCurChanIndex].struShelter[i]), &(dlg.m_struShelter[i]),sizeof(NET_DVR_SHELTER));
		}
		m_bSetChannelPara[m_iCurChanIndex] = TRUE;
	}
}

/*********************************************************
  Function:	OnBnClickedBtnMotionSetup
  Desc:		motion detect schedule, zone, etc
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnMotionSetup()
{
	CDlgRemoteMotionDetect dlgRemoteMotionDetect;

	g_lpMotionDetect = &(m_struPicCfg[m_iCurChanIndex].struMotion);
	dlgRemoteMotionDetect.m_iChanShowNum = m_iChanShowNum;
	dlgRemoteMotionDetect.m_lLoginID = m_lLoginID;
	dlgRemoteMotionDetect.m_dwAlarmOutNum = m_dwAlarmOutNum;
	dlgRemoteMotionDetect.m_iChanCount = m_iChanCount;
	dlgRemoteMotionDetect.m_dwDevIndex = m_iDeviceIndex;
	if (dlgRemoteMotionDetect.DoModal() == IDOK)
	{
		m_bSetChannelPara[m_iCurChanIndex] = TRUE;
	}
}

/*********************************************************
  Function:	OnBnClickedBtnHideAlarmSetup
  Desc:		view tamper settings 
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnHideAlarmSetup()
{
	CDlgRemoteHideAlarm dlgRemoteHideAlarm;

	g_lpHideAlarm = &(m_struPicCfg[m_iCurChanIndex].struHideAlarm);
	dlgRemoteHideAlarm.m_iChanShowNum = m_iChanShowNum;
	dlgRemoteHideAlarm.m_lLoginID = m_lLoginID;
	dlgRemoteHideAlarm.m_dwAlarmOutNum = m_dwAlarmOutNum;
	dlgRemoteHideAlarm.m_dwDevIndex = m_iDeviceIndex;
	if (dlgRemoteHideAlarm.DoModal() == IDOK)
	{
		m_bSetChannelPara[m_iCurChanIndex] = TRUE;
	}
}

/*********************************************************
  Function:	OnBnClickedBtnVilostSetup
  Desc:		video loss settings
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnVilostSetup()
{
	CDlgRemoteVideoInLost dlgRemoteVideoInLost;

	g_lpVILost = &(m_struPicCfg[m_iCurChanIndex].struVILost);
	dlgRemoteVideoInLost.m_iChanShowNum = m_iChanShowNum;
	dlgRemoteVideoInLost.m_lLoginID = m_lLoginID;
	dlgRemoteVideoInLost.m_dwAlarmOutNum = m_dwAlarmOutNum;
	dlgRemoteVideoInLost.m_dwDevIndex = m_iDeviceIndex;
	if (dlgRemoteVideoInLost.DoModal() == IDOK)
	{
		m_bSetChannelPara[m_iCurChanIndex] = TRUE;
	}
}

/*********************************************************
  Function:	OnBnClickedBtnString	
  Desc:		string overlay settings
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnString()
{
	CDlgRemoteShowString dlgRemoteShowString;

	dlgRemoteShowString.m_lLoginID = m_lLoginID;
	dlgRemoteShowString.m_iChanShowNum = m_iChanShowNum;
	dlgRemoteShowString.DoModal();
}

/*********************************************************
  Function:	OnBnClickedBtnChanCopy
  Desc:		copy channel configuration
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnChanCopy()
{
	UpdateData(TRUE);
	int nTemp = 0; 
	int i = 0, j = 0, k = 0;
	m_iCopyChanIndex = m_comboCopyChan.GetItemData(m_comboCopyChan.GetCurSel()) - 1;
	if (m_iCopyChanIndex == m_iCurChanIndex)
	{
		return;
	}

	if (m_iCopyChanIndex == -1)
	{
		for (i=0; i<MAX_CHANNUM_V30; i++)
		{
			if (i == m_iCurChanIndex|| !g_struDeviceInfo[m_iDeviceIndex].struChanInfo[i].bEnable)//ȥûлȡ豸ͨͨȴڹر״̬ͨ
			{
				continue;// || !m_bGetChannelPara[i] 
			}
			//copy comrpession parameters
				//main stream
			CheckRebootParam( &(m_struCompressionCfg[i].struNormHighRecordPara.byStreamType),\
				m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byStreamType, FALSE);
			m_struCompressionCfg[i].struNormHighRecordPara.byPicQuality = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byPicQuality;
			m_struCompressionCfg[i].struNormHighRecordPara.dwVideoBitrate = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoBitrate;
			CheckRebootParam( &(m_struCompressionCfg[i].struNormHighRecordPara.byResolution),\
				m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution, TRUE);
			m_struCompressionCfg[i].struNormHighRecordPara.dwVideoFrameRate = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoFrameRate;
			m_struCompressionCfg[i].struNormHighRecordPara.byBitrateType = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byBitrateType;
			m_struCompressionCfg[i].struNormHighRecordPara.byIntervalBPFrame = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byIntervalBPFrame;	
			m_struCompressionCfg[i].struNormHighRecordPara.wIntervalFrameI = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.wIntervalFrameI;
// 			m_struCompressionCfg[i].struNormHighRecordPara.byVideoEncType = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byVideoEncType;	
// 			m_struCompressionCfg[i].struNormHighRecordPara.byAudioEncType = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byAudioEncType;
		
				//sub stream
			m_struCompressionCfg[i].struNetPara.byStreamType = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byStreamType;
			m_struCompressionCfg[i].struNetPara.byPicQuality = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byPicQuality;
			m_struCompressionCfg[i].struNetPara.dwVideoBitrate = m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoBitrate;
			m_struCompressionCfg[i].struNetPara.byResolution = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byResolution;
			m_struCompressionCfg[i].struNetPara.dwVideoFrameRate = m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoFrameRate;
			m_struCompressionCfg[i].struNetPara.byBitrateType = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byBitrateType;
			m_struCompressionCfg[i].struNetPara.byIntervalBPFrame = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byIntervalBPFrame;	
			m_struCompressionCfg[i].struNetPara.wIntervalFrameI = m_struCompressionCfg[m_iCurChanIndex].struNetPara.wIntervalFrameI;
				//event
			m_struCompressionCfg[i].struEventRecordPara.byStreamType = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byStreamType;
			m_struCompressionCfg[i].struEventRecordPara.byPicQuality = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byPicQuality;
			m_struCompressionCfg[i].struEventRecordPara.dwVideoBitrate = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoBitrate;
			m_struCompressionCfg[i].struEventRecordPara.byResolution = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byResolution;
			m_struCompressionCfg[i].struEventRecordPara.dwVideoFrameRate = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoFrameRate;
			m_struCompressionCfg[i].struEventRecordPara.byBitrateType = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byBitrateType;
			m_struCompressionCfg[i].struEventRecordPara.byIntervalBPFrame = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byIntervalBPFrame;	
			m_struCompressionCfg[i].struEventRecordPara.wIntervalFrameI = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.wIntervalFrameI;

				
// 			m_struCompressionCfg[i].struNormLowRecordPara.byStreamType = m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byStreamType;
// 			m_struCompressionCfg[i].struNormLowRecordPara.byPicQuality = m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byPicQuality;
// 			m_struCompressionCfg[i].struNormLowRecordPara.dwVideoBitrate = m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.dwVideoBitrate;
// 			m_struCompressionCfg[i].struNormLowRecordPara.byResolution = m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byResolution;
// 			m_struCompressionCfg[i].struNormLowRecordPara.dwVideoFrameRate = m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.dwVideoFrameRate;
// 			m_struCompressionCfg[i].struNormLowRecordPara.byBitrateType = m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byBitrateType;
// 			m_struCompressionCfg[i].struNormLowRecordPara.byIntervalBPFrame = m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byIntervalBPFrame;	
// 			m_struCompressionCfg[i].struNormLowRecordPara.wIntervalFrameI = m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.wIntervalFrameI;

			//recording paramerters
			m_struRemoteRecCfg[i].dwRecord = m_struRemoteRecCfg[m_iCurChanIndex].dwRecord;
			m_struRemoteRecCfg[i].dwRecordTime = m_struRemoteRecCfg[m_iCurChanIndex].dwRecordTime;
			m_struRemoteRecCfg[i].dwPreRecordTime = m_struRemoteRecCfg[m_iCurChanIndex].dwPreRecordTime;
			m_struRemoteRecCfg[i].dwRecorderDuration = m_struRemoteRecCfg[m_iCurChanIndex].dwRecorderDuration;
			//copy time schedule
			for (k=0; k<MAX_DAYS; k++)
			{
				memcpy(&(m_struRemoteRecCfg[i].struRecAllDay[k]), &(m_struRemoteRecCfg[m_iCurChanIndex].struRecAllDay[k]), sizeof(NET_DVR_RECORDDAY));
				for (j=0; j<MAX_TIMESEGMENT_V30; j++)
				{
					memcpy(&m_struRemoteRecCfg[i].struRecordSched[k][j],&m_struRemoteRecCfg[m_iCurChanIndex].struRecordSched[k][j],sizeof(NET_DVR_RECORDSCHED));				
				}
			}

			//image parameters
			m_struPicCfg[i].dwEnableHide = m_bCheckHideArea;
			m_struPicCfg[i].struMotion.byEnableHandleMotion = m_bCheckMotion;			
			if (!m_bCheckHideAlarm)
			{
				m_struPicCfg[i].struHideAlarm.dwEnableHideAlarm = m_bCheckHideAlarm;
			}
			m_struPicCfg[i].dwShowChanName = m_bCheckChanName;
			m_struPicCfg[i].wShowNameTopLeftX = m_iChanNameX;
			m_struPicCfg[i].wShowNameTopLeftY = m_iChanNameY;
			m_struPicCfg[i].dwShowOsd = m_bCheckOsd;
			m_struPicCfg[i].wOSDTopLeftX = m_iOsdX;
			m_struPicCfg[i].wOSDTopLeftY = m_iOsdY;
			m_struPicCfg[i].byDispWeek = m_bChkDispWeek;
			m_struPicCfg[i].byOSDAttrib = m_comboOsdAttrib.GetCurSel()+1;
			m_struPicCfg[i].byOSDType = m_comboOsdType.GetCurSel();
			m_struPicCfg[i].byHourOSDType = m_comboHourType.GetCurSel();
			m_struPicCfg[i].struVILost.byEnableHandleVILost = m_bCheckVILost;
//			m_struPicCfg[i].struAULost.byEnableHandleVILost = m_bChkAuLost;
				//copy image parameters
//			memcpy(&(m_struPicCfg[i].struViColor), &(m_struPicCfg[m_iCurChanIndex].struViColor), sizeof(NET_DVR_VICOLOR));
			m_bSetChannelPara[i] = TRUE;
		}		
	}
	else
	{
		//main stream
		CheckRebootParam( &(m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.byStreamType),\
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byStreamType, FALSE);
		m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.byPicQuality = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byPicQuality;
		m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.dwVideoBitrate = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoBitrate;
		CheckRebootParam( &(m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.byResolution),\
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution, TRUE);
		m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.dwVideoFrameRate = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoFrameRate;
		m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.byBitrateType = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byBitrateType;
		m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.byIntervalBPFrame = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byIntervalBPFrame;	
		m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.wIntervalFrameI = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.wIntervalFrameI;
// 			m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.byVideoEncType = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byVideoEncType;	
// 			m_struCompressionCfg[m_iCopyChanIndex].struNormHighRecordPara.byAudioEncType = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byAudioEncType;

		//sub stream
		m_struCompressionCfg[m_iCopyChanIndex].struNetPara.byStreamType = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byStreamType;
		m_struCompressionCfg[m_iCopyChanIndex].struNetPara.byPicQuality = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byPicQuality;
		m_struCompressionCfg[m_iCopyChanIndex].struNetPara.dwVideoBitrate = m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoBitrate;
		m_struCompressionCfg[m_iCopyChanIndex].struNetPara.byResolution = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byResolution;
		m_struCompressionCfg[m_iCopyChanIndex].struNetPara.dwVideoFrameRate = m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoFrameRate;
		m_struCompressionCfg[m_iCopyChanIndex].struNetPara.byBitrateType = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byBitrateType;
		m_struCompressionCfg[m_iCopyChanIndex].struNetPara.byIntervalBPFrame = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byIntervalBPFrame;	
		m_struCompressionCfg[m_iCopyChanIndex].struNetPara.wIntervalFrameI = m_struCompressionCfg[m_iCurChanIndex].struNetPara.wIntervalFrameI;
			//event
		m_struCompressionCfg[m_iCopyChanIndex].struEventRecordPara.byStreamType = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byStreamType;
		m_struCompressionCfg[m_iCopyChanIndex].struEventRecordPara.byPicQuality = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byPicQuality;
		m_struCompressionCfg[m_iCopyChanIndex].struEventRecordPara.dwVideoBitrate = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoBitrate;
		m_struCompressionCfg[m_iCopyChanIndex].struEventRecordPara.byResolution = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byResolution;
		m_struCompressionCfg[m_iCopyChanIndex].struEventRecordPara.dwVideoFrameRate = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoFrameRate;
		m_struCompressionCfg[m_iCopyChanIndex].struEventRecordPara.byBitrateType = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byBitrateType;
		m_struCompressionCfg[m_iCopyChanIndex].struEventRecordPara.byIntervalBPFrame = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byIntervalBPFrame;	
		m_struCompressionCfg[m_iCopyChanIndex].struEventRecordPara.wIntervalFrameI = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.wIntervalFrameI;

		//remote record parameters
		m_struRemoteRecCfg[m_iCopyChanIndex].dwRecord = m_bCheckRecord;
		m_struRemoteRecCfg[m_iCopyChanIndex].dwRecordTime = m_comboRecDelay.GetCurSel();
		m_struRemoteRecCfg[m_iCopyChanIndex].dwPreRecordTime = m_comboPreRecordTime.GetCurSel();
		m_struRemoteRecCfg[m_iCopyChanIndex].dwRecorderDuration = m_dwDurationTime;
		for (k=0; k<MAX_DAYS; k++)
		{
			memcpy(&(m_struRemoteRecCfg[m_iCopyChanIndex].struRecAllDay[k]), &(m_struRemoteRecCfg[m_iCurChanIndex].struRecAllDay[k]), sizeof(NET_DVR_RECORDDAY));
			for (j=0; j<MAX_TIMESEGMENT_V30; j++)
			{
				memcpy(&m_struRemoteRecCfg[m_iCopyChanIndex].struRecordSched[k][j],&m_struRemoteRecCfg[m_iCurChanIndex].struRecordSched[k][j],sizeof(NET_DVR_RECORDSCHED));				
			}
		}

		m_struPicCfg[m_iCopyChanIndex].dwEnableHide = m_bCheckHideArea;
		m_struPicCfg[m_iCopyChanIndex].struMotion.byEnableHandleMotion = m_bCheckMotion;
		if (!m_bCheckHideAlarm)
		{
			m_struPicCfg[m_iCopyChanIndex].struHideAlarm.dwEnableHideAlarm = m_bCheckHideAlarm;
		}
		m_struPicCfg[m_iCopyChanIndex].dwShowChanName = m_bCheckChanName;
		m_struPicCfg[m_iCopyChanIndex].wShowNameTopLeftX = m_iChanNameX;
		m_struPicCfg[m_iCopyChanIndex].wShowNameTopLeftY = m_iChanNameY;
		m_struPicCfg[m_iCopyChanIndex].dwShowOsd = m_bCheckOsd;
		m_struPicCfg[m_iCopyChanIndex].wOSDTopLeftX = m_iOsdX;
		m_struPicCfg[m_iCopyChanIndex].wOSDTopLeftY = m_iOsdY;
		m_struPicCfg[m_iCopyChanIndex].byDispWeek = m_bChkDispWeek;
		m_struPicCfg[m_iCopyChanIndex].byOSDAttrib = m_comboOsdAttrib.GetCurSel()+1;
		m_struPicCfg[m_iCopyChanIndex].byOSDType = m_comboOsdType.GetCurSel();
		m_struPicCfg[m_iCopyChanIndex].struVILost.byEnableHandleVILost = m_bCheckVILost;
		m_bSetChannelPara[m_iCopyChanIndex] = TRUE;
	}
}

/*********************************************************
  Function:	OnBnClickedBtnChanCfgOk
  Desc:		Confirm current channel configuration
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnChanCfgOk()
{
	SaveLastCompressTypePara();
	
	UpdateData(TRUE);	
	OnBnClickedBtnCmpOk();
	int nTemp = 0;

	//record paramerters
	m_struRemoteRecCfg[m_iCurChanIndex].dwRecord = m_bCheckRecord;
	m_struRemoteRecCfg[m_iCurChanIndex].dwRecordTime = m_comboRecDelay.GetCurSel();
	m_struRemoteRecCfg[m_iCurChanIndex].dwPreRecordTime = m_comboPreRecordTime.GetCurSel();
	m_struRemoteRecCfg[m_iCurChanIndex].dwRecorderDuration = m_dwDurationTime;
	m_struRemoteRecCfg[m_iCurChanIndex].byRedundancyRec = m_bChkRedundancyRec;
	m_struRemoteRecCfg[m_iCurChanIndex].byAudioRec = m_bChkAudioRec;

	//channel image paramerters
	memcpy(m_struPicCfg[m_iCurChanIndex].sChanName,m_csChanName,NAME_LEN);
	m_struPicCfg[m_iCurChanIndex].dwEnableHide = m_bCheckHideArea;
	m_struPicCfg[m_iCurChanIndex].struMotion.byEnableHandleMotion = m_bCheckMotion;
	if (!m_bCheckHideAlarm)
	{
		m_struPicCfg[m_iCurChanIndex].struHideAlarm.dwEnableHideAlarm = m_bCheckHideAlarm;
	}
	m_struPicCfg[m_iCurChanIndex].dwShowChanName = m_bCheckChanName;
	m_struPicCfg[m_iCurChanIndex].wShowNameTopLeftX = m_iChanNameX;
	m_struPicCfg[m_iCurChanIndex].wShowNameTopLeftY = m_iChanNameY;
	m_struPicCfg[m_iCurChanIndex].dwShowOsd = m_bCheckOsd;
	m_struPicCfg[m_iCurChanIndex].wOSDTopLeftX = m_iOsdX;
	m_struPicCfg[m_iCurChanIndex].wOSDTopLeftY = m_iOsdY;
	m_struPicCfg[m_iCurChanIndex].byDispWeek = m_bChkDispWeek;
	m_struPicCfg[m_iCurChanIndex].byOSDAttrib = m_comboOsdAttrib.GetCurSel()+1;
	m_struPicCfg[m_iCurChanIndex].byOSDType = m_comboOsdType.GetCurSel();
	m_struPicCfg[m_iCurChanIndex].byHourOSDType = m_comboHourType.GetCurSel();
	m_struPicCfg[m_iCurChanIndex].struVILost.byEnableHandleVILost = m_bCheckVILost;	
//	m_struPicCfg[m_iCurChanIndex].struAULost.byEnableHandleVILost = m_bChkAuLost;
	
	m_bSetChannelPara[m_iCurChanIndex] = TRUE;
	GetDlgItem(IDC_BTN_CHAN_COPY)->EnableWindow(TRUE);
}

/*********************************************************
Function:	CfgSetup
Desc:		Set image paramerters
Input:	
Output:	
Return:	TRUE,setting succeeds;FALSE,settings fails;
**********************************************************/
BOOL CSubDlgChanCfg::CfgSetup()
{
	CString sTemp;
	int i = 0;
	int iChanShow = 0;//display channel number
	BOOL bRet = TRUE;
	char szLan[128] = {0};
	//the confirm button on channel setting is only valid for the selected channel, users need to copy the settings to other channels
	for (i=0; i<MAX_CHANNUM_V30; i++)
	{
		iChanShow = i+m_lStartChannel;
		if (m_bSetChannelPara[i] && g_struDeviceInfo[m_iDeviceIndex].struChanInfo[i].bEnable)
		{
			if (!NET_DVR_SetDVRConfig(m_lLoginID,NET_DVR_SET_COMPRESSCFG_V30, iChanShow,&(m_struCompressionCfg[i]), sizeof(NET_DVR_COMPRESSIONCFG_V30)))
			{
				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_SET_COMPRESSCFG_V30 %s", g_struDeviceInfo[m_iDeviceIndex].struChanInfo[i].chChanName);
				g_StringLanType(szLan, "ʧ", "Save failed");
				AfxMessageBox(szLan);
				return FALSE;
			}
// 			else
// 			{
// 				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_SET_COMPRESSCFG_V30  %s", g_struDeviceInfo[m_iDeviceIndex].struChanInfo[i].chChanName)	
// 			}

			if (!NET_DVR_SetDVRConfig(m_lLoginID,NET_DVR_SET_RECORDCFG_V30, iChanShow,&(m_struRemoteRecCfg[i]), sizeof(NET_DVR_RECORD_V30)))	
			{
				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_SET_RECORDCFG_V30 %s", g_struDeviceInfo[m_iDeviceIndex].struChanInfo[i].chChanName);
				g_StringLanType(szLan, "ʧ", "Save failed");
				AfxMessageBox(szLan);
				return FALSE;
			}
			if (!NET_DVR_SetDVRConfig(m_lLoginID, NET_DVR_SET_PICCFG_V30, iChanShow, &(m_struPicCfg[i]), sizeof(NET_DVR_PICCFG_V30)))
			{
				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "chan[%d]: NET_DVR_SET_PICCFG_V30", iChanShow);
				g_StringLanType(szLan, "ʧ", "Save failed");
				AfxMessageBox(szLan);
				return FALSE;
			}
// 			else
// 			{
// 				g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_SET_PICCFG_V30 %s", g_struDeviceInfo[m_iDeviceIndex].struChanInfo[i].chChanName)
// 			}
			m_bSetChannelPara[i] = FALSE;
		}
	}
	g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "chan parameter set successfully!"); 
	return TRUE;
}

/*********************************************************
  Function:	OnBnClickedBtnChanCfgExit
  Desc:		cancel current channel settings
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnChanCfgExit()
{
	for (int i=0; i<m_iChanCount; i++)
	{
		m_bSetChannelPara[i] = FALSE;
	}
}

/*********************************************************
  Function:	OnBnClickedChkRecord
  Desc:		set remote record schedule or not
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedChkRecord()
{
	UpdateData(TRUE);
	if (m_bCheckRecord)
	{
		GetDlgItem(IDC_BTN_REMOTE_RECORD_SETUP)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_BTN_REMOTE_RECORD_SETUP)->EnableWindow(FALSE);
	}
}

/*********************************************************
  Function:	OnBnClickedChkHideArea
  Desc:		set privacy mask or not
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedChkHideArea()
{
	UpdateData(TRUE);
	if (m_bCheckHideArea)
	{
		GetDlgItem(IDC_BTN_HIDE_SETUP)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_BTN_HIDE_SETUP)->EnableWindow(FALSE);
	}
}

/*********************************************************
  Function:	OnBnClickedChkOsd
  Desc:		set osd or not
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedChkOsd()
{
	UpdateData(TRUE);
	EnableOsd(m_bCheckOsd);
	UpdateData(FALSE);
}

/*********************************************************
  Function:	EnableOsd
  Desc:		 status of osd parameters in the control
  Input:	bEnable,TRUE,enable;FALSE,disable;
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::EnableOsd(BOOL bEnable) 
{
	GetDlgItem(IDC_EDIT_OSD_X)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_OSD_Y)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_OSD_ATTRIB)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_OSD_TYPE)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHK_DISPLAY_WEEK)->EnableWindow(bEnable);
}

/*********************************************************
  Function:	OnBnClickedChkChanNamePos
  Desc:		set channel name position or not
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedChkChanNamePos()
{
	UpdateData(TRUE);
	EnableChanname(m_bCheckChanName);
	UpdateData(FALSE);
}

/*********************************************************
Function:	EnableChanname
Desc:		channel name position parameters status on the control
Input:	bEnable,TRUE,enable;FALSE,disable;
Output:	
Return:	
**********************************************************/
void CSubDlgChanCfg::EnableChanname(BOOL bEnable) 
{
	GetDlgItem(IDC_EDIT_CHAN_NAME_X)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_CHAN_NAME_Y)->EnableWindow(bEnable);
}

/*********************************************************
  Function:	OnCbnSelchangeComboCopyChan
  Desc:		select the channel number to be copied to
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnCbnSelchangeComboCopyChan()
{
	UpdateData(TRUE);
	DWORD dwSel = m_comboCopyChan.GetCurSel();
	CString csChan = _T("");
	if (dwSel == 0)
	{
		m_iCopyChanIndex =  - 1;
	}
	else
	{
		m_comboCopyChan.SetItemData(1, 1);
		dwSel = m_comboCopyChan.GetItemData(1);
		m_comboCopyChan.GetDlgItemText(dwSel, csChan);
		m_iCopyChanIndex = atoi(csChan.GetBuffer(0));
	}	
}

/*********************************************************
  Function:	OnBnClickedChkMotion
  Desc:		setmotion detect or not
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedChkMotion()
{
	UpdateData(TRUE);
	GetDlgItem(IDC_BTN_MOTION_SETUP)->EnableWindow(m_bCheckMotion);
}

/*********************************************************
  Function:	OnBnClickedChkHideAlarm
  Desc:		set view tamper detect or not
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedChkHideAlarm()
{
	UpdateData(TRUE);
	GetDlgItem(IDC_BTN_HIDE_ALARM_SETUP)->EnableWindow(m_bCheckHideAlarm);
}

/*********************************************************
  Function:	OnBnClickedChkVilost
  Desc:		set video loss detect or not
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedChkVilost()
{
	UpdateData(TRUE);
	GetDlgItem(IDC_BTN_VILOST_SETUP)->EnableWindow(m_bCheckVILost);
}


/*********************************************************
  Function:	FrameIIntervalMap
  Desc:		frame interval
  Input:	
  Output:	
  Return:	
**********************************************************/
WORD CSubDlgChanCfg::FrameIIntervalMap(DWORD nSelFrameRate)
{
	WORD nRet = 0;
	switch (nSelFrameRate)
	{
	case 0:
		nRet = 25;
		break;
	case 6:
		nRet = 2;
		break;
	case 7:
		nRet = 4;
		break;
	case 8:
		nRet = 6;
		break;
	case 9:
		nRet = 8;
		break;
	case 10:
		nRet = 10;
		break;
	case 11:
		nRet = 12;
		break;
	case 12:
		nRet = 16;
		break;
	case 13:
		nRet = 20;
		break;
	case 14:
		nRet = 15;
		break;
	case 15:
		nRet = 18;
		break;
	case 16:
		nRet = 22;
		break;
	default:
		nRet = 1;
	}
	nRet *= 4;
	return nRet;
}

/*********************************************************
  Function:	OnCbnSelchangeComboFrameRate
  Desc:		main stream settings
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnCbnSelchangeComboFrameRate()
{
	UpdateData(TRUE);
	WORD nSel = m_comboFrameRate.GetCurSel();
	m_iFrameIInterval = FrameIIntervalMap(nSel);	
	UpdateData(FALSE);
}

/*********************************************************
Function:	UpdateCompressionInfo
Desc:		update compression paraemeters and control display
Input:	
Output:	
Return:	
**********************************************************/
void CSubDlgChanCfg::UpdateCompressionInfo()
{
	m_comboResolution.ResetContent();
	m_comboResolution.AddString("DCIF");
	m_comboResolution.AddString("CIF");
	m_comboResolution.AddString("QCIF");
	m_comboResolution.AddString("4CIF");
	m_comboResolution.AddString("2CIF");
	m_comboResolution.AddString("VGA(640*480)"); 
	m_comboResolution.AddString("UXGA(1600*1200)"); 
	m_comboResolution.AddString("SVGA(800*600)");
	m_comboResolution.AddString("HD720p(1280*720)"); 
//	m_comboResolution.AddString("SXGA(1280*1024)");
	m_comboResolution.AddString("XVGA");
	m_comboResolution.AddString("HD900p");
	DWORD dwResoltion;
	switch (m_iCompressionTypeSel)
	{
	case NORM_HIGH_STREAM_COMPRESSION:
		GetDlgItem(IDC_COMBO_STREAM_TYPE)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_RESOLUTION)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_FRAME_I_INTERVAL)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_FRAME_BP_INTERVAL)->EnableWindow(TRUE);
		if ((m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoBitrate >> 31) && 0x01)
		{
			GetDlgItem(IDC_EDIT_BIT_RATE)->EnableWindow(TRUE);
			m_comboBitRate.SetCurSel(22);		//adjust bit rate settings
			m_iBitRate = (m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoBitrate & 0x7fffffff)/1024;
		}
		else
		{
			m_comboBitRate.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoBitrate-2);			
			m_iBitRate = 0;
			GetDlgItem(IDC_EDIT_BIT_RATE)->EnableWindow(FALSE);
		}	

		dwResoltion = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution;
		if (dwResoltion >=16)
		{
			dwResoltion = dwResoltion - 11;
		}
		m_comboResolution.SetCurSel(dwResoltion);
		m_comboStreamType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byStreamType);
		m_comboImageQuality.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byPicQuality);
		m_comboBitRateType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byBitrateType);
		m_comboFrameRate.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoFrameRate);
		m_comboFrameBPInterval.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byIntervalBPFrame);	
		m_iFrameIInterval = m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.wIntervalFrameI;

		m_comboVideoType.EnableWindow(FALSE);
		m_comboAudioType.EnableWindow(FALSE);
		m_comboVideoType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byVideoEncType);
		m_comboAudioType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byAudioEncType);

		break;
	case EVENT_INVOKE_COMPRESSION:
		if (m_iCurChanIndex < MAX_ANALOG_CHANNUM)
		{
			EnableEventCtrl(TRUE);
		}
		else
		{
			EnableEventCtrl(FALSE);
		}
		

		if ((m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoBitrate >> 31) && 0x01)
		{
			GetDlgItem(IDC_EDIT_BIT_RATE)->EnableWindow(TRUE);
			m_comboBitRate.SetCurSel(22);		//adjust bit rate settings
			m_iBitRate = (m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoBitrate & 0x7fffffff)/1024;
		}
		else
		{
			m_comboBitRate.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoBitrate-2);			
			m_iBitRate = 0;
			GetDlgItem(IDC_EDIT_BIT_RATE)->EnableWindow(FALSE);
		}
		dwResoltion = m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byResolution;
		if (dwResoltion >=16)
		{
			dwResoltion = dwResoltion - 11;
		}
		m_comboResolution.SetCurSel(dwResoltion);
		m_comboStreamType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byStreamType);
		m_comboImageQuality.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byPicQuality);
		m_comboBitRateType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byBitrateType);
		m_comboFrameRate.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoFrameRate);
	
		m_comboVideoType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byVideoEncType);
		m_comboAudioType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byAudioEncType);
		break;
	case SUB_STREAM_COMPRESSION:	
		m_comboResolution.ResetContent();
		m_comboResolution.AddString("CIF");
		m_comboResolution.AddString("QCIF");
		m_comboResolution.AddString("4CIF");

		GetDlgItem(IDC_COMBO_STREAM_TYPE)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_RESOLUTION)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_FRAME_I_INTERVAL)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_FRAME_BP_INTERVAL)->EnableWindow(TRUE);
		if ((m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoBitrate >> 31) && 0x01)
		{
			GetDlgItem(IDC_EDIT_BIT_RATE)->EnableWindow(TRUE);
			m_comboBitRate.SetCurSel(22);		//adjust bit rate settings
			m_iBitRate = (m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoBitrate & 0x7fffffff)/1024;
		}
		else
		{
			m_comboBitRate.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoBitrate-2);			
			m_iBitRate = 0;
			GetDlgItem(IDC_EDIT_BIT_RATE)->EnableWindow(FALSE);
		}

		dwResoltion = m_struCompressionCfg[m_iCurChanIndex].struNetPara.byResolution;
// 		if (dwResoltion >=16)
// 		{
// 			dwResoltion = dwResoltion - 11;
// 		}
		m_comboResolution.SetCurSel(dwResoltion-1);
		m_comboStreamType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNetPara.byStreamType);
		m_comboImageQuality.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNetPara.byPicQuality);
		m_comboBitRateType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNetPara.byBitrateType);
		m_comboFrameRate.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoFrameRate);	
		m_comboFrameBPInterval.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNetPara.byIntervalBPFrame);	
		m_iFrameIInterval = m_struCompressionCfg[m_iCurChanIndex].struNetPara.wIntervalFrameI;
		m_comboVideoType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNetPara.byVideoEncType);
		m_comboAudioType.SetCurSel(m_struCompressionCfg[m_iCurChanIndex].struNetPara.byAudioEncType);
		break;
	default:
		break;
	}
}

/*********************************************************
Function:	OnCbnSelchangeComboCompressionType
Desc:		update compression parameters and control display
Input:	
Output:	
Return:	
**********************************************************/
void CSubDlgChanCfg::OnCbnSelchangeComboCompressionType()
{
	SaveLastCompressTypePara();
	UpdateData(TRUE);
	int iCmpType = NORM_HIGH_STREAM_COMPRESSION;
	switch(m_comboCompressionType.GetCurSel())
	{
	case 0:
		iCmpType = NORM_HIGH_STREAM_COMPRESSION;
		break;
	case 1:
		iCmpType = SUB_STREAM_COMPRESSION;
		break;
	case 2:
		iCmpType = EVENT_INVOKE_COMPRESSION;
		break;
	default:
		break;
	}
	if (m_iCompressionTypeSel == iCmpType)
	{
		return;
	}
	m_iCompressionTypeSel = iCmpType;
	UpdateCompressionInfo();
	UpdateData(FALSE);
}

/*********************************************************
  Function:	OnBnClickedBtnCmpOk
  Desc:		finish comression paramertes modification
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnBnClickedBtnCmpOk()
{
	UpdateData(TRUE);
	DWORD dwDefBitRate = 0;
	BYTE byEventResolution = 0;
	switch (m_iCompressionTypeSel)
	{
	case NORM_HIGH_STREAM_COMPRESSION:
		CheckRebootParam( &(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byStreamType),\
			m_comboStreamType.GetCurSel(), FALSE);

		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byPicQuality = m_comboImageQuality.GetCurSel();
		if (m_comboBitRate.GetCurSel() == 22)	//adjust bit rate settings
		{
			dwDefBitRate = m_iBitRate*1024;		
			if (dwDefBitRate < 32*1024)
			{
				dwDefBitRate = 32*1024;
			}
			if (dwDefBitRate > 8192*1024)
			{
				dwDefBitRate =  8192*1024;
			}
			dwDefBitRate |= 0x80000000;
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoBitrate = dwDefBitRate;
		}
		else
		{
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoBitrate = m_comboBitRate.GetCurSel()+2;
		}
		CheckRebootParam( &(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution),\
			m_comboResolution.GetCurSel(), TRUE);
		if (m_comboResolution.GetCurSel() > 4)
		{
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution = m_comboResolution.GetCurSel()+11;
		}
		else
		{
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution = m_comboResolution.GetCurSel();
		}
	//	m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution = m_comboResolution.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoFrameRate = m_comboFrameRate.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byBitrateType = m_comboBitRateType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byIntervalBPFrame = m_comboFrameBPInterval.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.wIntervalFrameI = m_iFrameIInterval;

		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byVideoEncType = m_comboVideoType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byAudioEncType = m_comboAudioType.GetCurSel();		
		break;
	case SUB_STREAM_COMPRESSION:
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byStreamType = m_comboStreamType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byPicQuality = m_comboImageQuality.GetCurSel();
		if (m_comboBitRate.GetCurSel() == 22)	//adjust bit rate settings
		{
			dwDefBitRate = m_iBitRate*1024;		
			if (dwDefBitRate < 32*1024)
			{
				dwDefBitRate = 32*1024;
			}
			if (dwDefBitRate > 8192*1024)
			{
				dwDefBitRate =  8192*1024;
			}
			dwDefBitRate |= 0x80000000;
			m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoBitrate = dwDefBitRate;
		}
		else
		{
			m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoBitrate = m_comboBitRate.GetCurSel()+2;
		}
		
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byResolution = m_comboResolution.GetCurSel()+1;
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoFrameRate = m_comboFrameRate.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byBitrateType = m_comboBitRateType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byIntervalBPFrame = m_comboFrameBPInterval.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.wIntervalFrameI = m_iFrameIInterval;
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byVideoEncType = m_comboVideoType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byAudioEncType = m_comboAudioType.GetCurSel();		
		break;
	case EVENT_INVOKE_COMPRESSION:
		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byStreamType = m_comboStreamType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byPicQuality = m_comboImageQuality.GetCurSel();
		if (m_comboBitRate.GetCurSel() == 22)	//adjust bit rate settings
		{
			dwDefBitRate = m_iBitRate*1024;		
			if (dwDefBitRate < 32*1024)
			{
				dwDefBitRate = 32*1024;
			}
			if (dwDefBitRate > 8192*1024)
			{
				dwDefBitRate =  8192*1024;
			}
			dwDefBitRate |= 0x80000000;
			m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoBitrate = dwDefBitRate;
		}
		else
		{
			m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoBitrate = m_comboBitRate.GetCurSel()+2;
		}

		byEventResolution = m_comboResolution.GetCurSel();
		if (byEventResolution >= 5)
		{
			byEventResolution = byEventResolution + 11;
		}

		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byResolution = byEventResolution;

		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoFrameRate = m_comboFrameRate.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byBitrateType = m_comboBitRateType.GetCurSel();
//		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byIntervalBPFrame = m_comboFrameBPInterval.GetCurSel();//same with main stream
		//m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.wIntervalFrameI = m_iFrameIInterval;//same with main stream

		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byVideoEncType = m_comboVideoType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byAudioEncType = m_comboAudioType.GetCurSel();
		break;
// 	case NORM_LOW_STREAM_COMPRESSION:
// 		CheckRebootParam( &(m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byStreamType),\
// 			m_comboStreamType.GetCurSel(), FALSE);
// 		m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byPicQuality = m_comboImageQuality.GetCurSel();
// 		if (m_comboBitRate.GetCurSel() == 22)	//adjust bit rate settings
// 		{
// 			dwDefBitRate = m_iBitRate*1024;		
// 			if (dwDefBitRate < 32*1024)
// 			{
// 				dwDefBitRate = 32*1024;
// 			}
// 			if (dwDefBitRate > 8192*1024)
// 			{
// 				dwDefBitRate =  8192*1024;
// 			}
// 			dwDefBitRate |= 0x80000000;
// 			m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.dwVideoBitrate = dwDefBitRate;
// 		}
// 		else
// 		{
// 			m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.dwVideoBitrate = m_comboBitRate.GetCurSel()+2;
// 		}
// 		CheckRebootParam( &(m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byResolution),\
// 			m_comboResolution.GetCurSel(), TRUE);
// 
// 		m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byResolution = m_comboResolution.GetCurSel();
// 		m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.dwVideoFrameRate = m_comboFrameRate.GetCurSel();
// 		m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byBitrateType = m_comboBitRateType.GetCurSel();
// 		m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byIntervalBPFrame = m_comboFrameBPInterval.GetCurSel();
// 		m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.wIntervalFrameI = m_iFrameIInterval;
//		m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byVideoEncType = m_comboVideoType.GetCurSel();
//		m_struCompressionCfg[m_iCurChanIndex].struNormLowRecordPara.byAudioEncType = m_comboAudioType.GetCurSel();
		break;
	default:
		break;
	}
}


/*********************************************************
  Function:	SaveLastCompressTypePara
  Desc:		Save parameter when Compress Type changed
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::SaveLastCompressTypePara()
{
    UpdateData(TRUE);
	DWORD dwDefBitRate = 0;
	BYTE byEventResolution = 0;
	switch (m_iCompressionTypeSel)
	{
	case NORM_HIGH_STREAM_COMPRESSION:
		CheckRebootParam( &(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byStreamType),\
			m_comboStreamType.GetCurSel(), FALSE);

		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byPicQuality = m_comboImageQuality.GetCurSel();
		if (m_comboBitRate.GetCurSel() == 22)	//Զ
		{
			dwDefBitRate = m_iBitRate*1024;		
			if (dwDefBitRate < 32*1024)
			{
				dwDefBitRate = 32*1024;
			}
			if (dwDefBitRate > 8192*1024)
			{
				dwDefBitRate =  8192*1024;
			}
			dwDefBitRate |= 0x80000000;
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoBitrate = dwDefBitRate;
		}
		else
		{
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoBitrate = m_comboBitRate.GetCurSel()+2;
		}
		CheckRebootParam( &(m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution),\
			m_comboResolution.GetCurSel(), TRUE);
		if (m_comboResolution.GetCurSel() > 4)
		{
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution = m_comboResolution.GetCurSel()+11;
		}
		else
		{
			m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byResolution = m_comboResolution.GetCurSel();
		}
		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.dwVideoFrameRate = m_comboFrameRate.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byBitrateType = m_comboBitRateType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.byIntervalBPFrame = m_comboFrameBPInterval.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNormHighRecordPara.wIntervalFrameI = m_iFrameIInterval;
	
		break;
	case SUB_STREAM_COMPRESSION:
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byStreamType = m_comboStreamType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byPicQuality = m_comboImageQuality.GetCurSel();
		if (m_comboBitRate.GetCurSel() == 22)	//Զ
		{
			dwDefBitRate = m_iBitRate*1024;		
			if (dwDefBitRate < 32*1024)
			{
				dwDefBitRate = 32*1024;
			}
			if (dwDefBitRate > 8192*1024)
			{
				dwDefBitRate =  8192*1024;
			}
			dwDefBitRate |= 0x80000000;
			m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoBitrate = dwDefBitRate;
		}
		else
		{
			m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoBitrate = m_comboBitRate.GetCurSel()+2;
		}
		
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byResolution = m_comboResolution.GetCurSel()+1;
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.dwVideoFrameRate = m_comboFrameRate.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byBitrateType = m_comboBitRateType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.byIntervalBPFrame = m_comboFrameBPInterval.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struNetPara.wIntervalFrameI = m_iFrameIInterval;		
		break;
	case EVENT_INVOKE_COMPRESSION:
		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byStreamType = m_comboStreamType.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byPicQuality = m_comboImageQuality.GetCurSel();
		if (m_comboBitRate.GetCurSel() == 22)	//Զ
		{
			dwDefBitRate = m_iBitRate*1024;		
			if (dwDefBitRate < 32*1024)
			{
				dwDefBitRate = 32*1024;
			}
			if (dwDefBitRate > 8192*1024)
			{
				dwDefBitRate =  8192*1024;
			}
			dwDefBitRate |= 0x80000000;
			m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoBitrate = dwDefBitRate;
		}
		else
		{
			m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoBitrate = m_comboBitRate.GetCurSel()+2;
		}

		byEventResolution = m_comboResolution.GetCurSel();
		if (byEventResolution >= 5)
		{
			byEventResolution = byEventResolution + 11;
		}

		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byResolution = byEventResolution;

		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.dwVideoFrameRate = m_comboFrameRate.GetCurSel();
		m_struCompressionCfg[m_iCurChanIndex].struEventRecordPara.byBitrateType = m_comboBitRateType.GetCurSel();
		break;
	default:
		break;
	}
}


/*********************************************************
  Function:	CheckRebootParam
  Desc:		detect parameter modification and judge if reboot is needed
  Input:	iCurVal,current value;iModVal,modified value;bJudge,judge device type or notFALSE:need reboot for all the devices;
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::CheckRebootParam(BYTE *byCurVal, int iModVal, BOOL bJudge)
{
	if ((*byCurVal) != iModVal)
	{
		*byCurVal = iModVal;
		if (!bJudge && g_pMainDlg->IsNeedRebootDevType())
		{
			g_bMustReboot = TRUE;
		}
		else
		{
			g_bMustReboot = FALSE;
		}
	}
}

/*********************************************************
  Function:	OnCbnSelchangeComboMaxBitRate
  Desc:		select user-defined bit rate
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgChanCfg::OnCbnSelchangeComboMaxBitRate()
{
	UpdateData(TRUE);
	if (m_comboBitRate.GetCurSel() == 22)	//self-define bitrate
	{
		GetDlgItem(IDC_EDIT_BIT_RATE)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_EDIT_BIT_RATE)->EnableWindow(FALSE);
	}
}

/*********************************************************
  Function:	EnableEventCtrl
  Desc:		enable  control or not, when the compression is event type
  Input:	bEnable, TRUE/FALSE
  Output:	none
  Return:	none
**********************************************************/
void CSubDlgChanCfg::EnableEventCtrl(BOOL bEnable)
{
	GetDlgItem(IDC_COMBO_STREAM_TYPE)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_RESOLUTION)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_FRAME_I_INTERVAL)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_FRAME_BP_INTERVAL)->EnableWindow(bEnable);
}

