/**********************************************************
FileName:    SubDlgDeviceCfg.cpp
Description: device info configuration    
Date:        2008/05/17
Note: 		<Global>struct, macro refer to GeneralDef.h, global variants and API refer to ClientDemo.cpp   
Modification History:      
    <version> <time>         <desc>
    <1.0    > <2008/05/17>       <created>
***********************************************************/


#include "stdafx.h"
#include "ClientDemo.h"
#include "SubDlgDeviceCfg.h"
#include ".\subdlgdevicecfg.h"
#include "MatDecDnsCfg.h"
#include "DlgRemoteNetNFS.h"
#include "DlgRemoteAdvanceNetConfig.h"
#include "DlgRemoteZone.h"
#include "DlgRtspConfig.h"
#include "DlgDeviceAudioTalkCode.h"

// CSubDlgDeviceCfg dialog
/*********************************************************
  Function:	CSubDlgDeviceCfg
  Desc:		Constructor
  Input:	
  Output:	
  Return:	
**********************************************************/
IMPLEMENT_DYNAMIC(CSubDlgDeviceCfg, CDialog)
CSubDlgDeviceCfg::CSubDlgDeviceCfg(CWnd* pParent /*=NULL*/)
	: CDialog(CSubDlgDeviceCfg::IDD, pParent)
	, m_csDeviceName(_T(""))
	, m_iHdNum(0)
	, m_iYKQID(0)
	, m_csIPResolver(_T(""))
	, m_csDeviceIP(_T(""))
	, m_csMultiIP(_T(""))
	, m_iMainPort(0)
	, m_csGatewayIP(_T(""))
	, m_csIPMask(_T(""))
	, m_csDeviceSerialNo(_T(""))
	, m_csSoftwareVersion(_T(""))
	, m_csHardwareVersion(_T(""))
	, m_csPanelVersion(_T(""))
	, m_csDspVersion(_T(""))
	, m_iAlarmInNum(0)
	, m_iAlarmOutNum(0)
	, m_iChanNum(0)
	, m_csMacAddr(_T(""))
	, m_csRemoteManageHost1IP(_T(""))
	, m_iHttpPort(0)
	, m_iRemoteManageHost1Port(0)
	, m_bDeviceCfgSet(FALSE)
	, m_bNetCfgSet(FALSE)
	, m_iDeviceIndex(-1)//CheckInitParam, iut is required that m_iDeviceIndex is initialed as -1
	, m_lLoginID(-1)
	, m_iChanCount(0)
	, m_lStartChannel(0)
	, m_dwUseZoom(0)
	, m_bSupScale(FALSE)
	, m_csAlarmHostIP(_T(""))
	, m_iAlarmHostPort(0)
	, m_iResolverPort(0)
	, m_csDNSIP1(_T("0.0.0.0"))
	, m_csDNSIP2(_T("0.0.0.0"))
	, m_wMTU(1500)
	, m_iAuxoManagePort(0)
	, m_bChkDhcp(FALSE)
{
	memset(&m_struDeviceCfg, 0, sizeof(m_struDeviceCfg));
	memset(&m_struNetCfg, 0, sizeof(m_struNetCfg));
}

/*********************************************************
  Function:	~CSubDlgDeviceCfg
  Desc:		destructor
  Input:	
  Output:	
  Return:	
**********************************************************/
CSubDlgDeviceCfg::~CSubDlgDeviceCfg()
{
}

/*********************************************************
Function:	DoDataExchange
Desc:		the map between control and variable
Input:	
Output:	
Return:	
**********************************************************/
void CSubDlgDeviceCfg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSubDlgDeviceCfg)
	DDX_Control(pDX, IDC_SUB_COMBO_MINOR_ZOOM, m_comboMinor);
	DDX_Text(pDX, IDC_SUB_EDIT_DEVICE_NAME, m_csDeviceName);
	DDX_Text(pDX, IDC_SUB_EDIT_HD_NUM, m_iHdNum);
	DDX_Text(pDX, IDC_SUB_EDIT_YKQID, m_iYKQID);
	DDX_Text(pDX, IDC_SUB_EDIT_RESOLVER_IP, m_csIPResolver);
	DDX_Text(pDX, IDC_SUB_EDIT_DEVIP, m_csDeviceIP);
	DDX_Text(pDX, IDC_SUB_EDIT_MULTIIP, m_csMultiIP);
	DDX_Text(pDX, IDC_SUB_EDIT_PORT, m_iMainPort);
	DDX_Text(pDX, IDC_SUB_EDIT_GATEWAY, m_csGatewayIP);
	DDX_Text(pDX, IDC_SUB_EDIT_IPMASK, m_csIPMask);
	DDX_Control(pDX, IDC_SUB_COMBO_NET_FACE, m_comboNetFace);
	DDX_Control(pDX, IDC_SUB_COMBO_USE_ZOOM, m_comboUseZoom);
	DDX_Text(pDX, IDC_SUB_EDIT_SERIAL, m_csDeviceSerialNo);
	DDX_Text(pDX, IDC_SUB_SOFTWARE_VERSION, m_csSoftwareVersion);
	DDX_Text(pDX, IDC_SUB_HARDWARE_VERSION, m_csHardwareVersion);
	DDX_Text(pDX, IDC_SUB_DSP_VERSION, m_csDspVersion);
	DDX_Text(pDX, IDC_SUB_ALARM_IN_NUM, m_iAlarmInNum);
	DDX_Text(pDX, IDC_SUB_ALARM_OUT_NUM, m_iAlarmOutNum);
	DDX_Text(pDX, IDC_SUB_EDIT_CHAN_NUM, m_iChanNum);
	DDX_Control(pDX, IDC_SUB_CYCLE_RECORD, m_comboCycleRec);
	DDX_Control(pDX, IDC_SUB_DEVICE_TYPE, m_comboDeviceType);
	DDX_Text(pDX, IDC_SUB_EDIT_MACIP, m_csMacAddr);
	DDX_Text(pDX, IDC_SUB_MANAGE_HOST1IP, m_csRemoteManageHost1IP);
	DDX_Text(pDX, IDC_AUXO_MANAGE_HOSTIP, m_csAuxoManageHostIP);
	DDX_Text(pDX, IDC_AUXO_MANAGE_HOSTPORT, m_iAuxoManagePort);
	DDX_Check(pDX, IDC_CHK_DHCP, m_bChkDhcp);
	DDX_Text(pDX, IDC_SUB_EDIT_HTTP_PORT, m_iHttpPort);
	DDX_Text(pDX, IDC_SUB_MANAGE_HOST1PORT, m_iRemoteManageHost1Port);
	DDX_Text(pDX, IDC_SUB_ALARM_HOSTIP, m_csAlarmHostIP);
	DDX_Text(pDX, IDC_SUB_ALARM_HOST_PORT, m_iAlarmHostPort);
	DDX_Text(pDX, IDC_SUB_RESOLVER_PORT, m_iResolverPort);
	DDX_Text(pDX, IDC_SUB_EDIT_DNS_IP1, m_csDNSIP1);
	DDX_Text(pDX, IDC_SUB_DNS_IP2, m_csDNSIP2);
	DDX_Text(pDX, IDC_SUB_MTU, m_wMTU);
	DDX_Text(pDX, IDC_SUB_QMB_VERSION, m_csPanelVersion);
	//}}AFX_DATA_MAP
}


/*********************************************************
Function:	BEGIN_MESSAGE_MAP
Desc:		the map between control and function
Input:	
Output:	
Return:	
**********************************************************/
BEGIN_MESSAGE_MAP(CSubDlgDeviceCfg, CDialog)
	//{{AFX_MSG_MAP(CSubDlgDeviceCfg)	
	ON_BN_CLICKED(IDC_BTN_REMOTE_NET_OK, OnBnClickedBtnRemoteNetOk)
	ON_BN_CLICKED(IDC_BTN_MAT_DEC_DNS, OnBnClickedBtnMatDecDns)
	ON_BN_CLICKED(IDC_BTN_ADVANCE_NET_SETUP, OnBnClickedBtnAdvanceNetSetup)
	ON_BN_CLICKED(IDC_BTN_REMOTE_NET_NFS, OnBnClickedBtnRemoteNetNfs)
	ON_BN_CLICKED(IDC_BTN_ZONE, OnBtnZone)
	ON_BN_CLICKED(IDC_BTN_RTSP, OnBtnRtsp)
	ON_BN_CLICKED(IDC_CHK_DHCP, OnChkDhcp)
	ON_BN_CLICKED(IDC_BTN_AUDIOTALKCODET_CONFIG, OnBtnAudiotalkcodetConfig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CSubDlgDeviceCfg message handlers
/*********************************************************
Function:	OnInitDialog
Desc:		Initialize the dialog
Input:	
Output:	
Return:	
**********************************************************/
BOOL CSubDlgDeviceCfg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CRect rc(0, 0, 0, 0);
	GetParent()->GetClientRect(&rc);
	((CTabCtrl*)GetParent())->AdjustRect(FALSE, &rc);
	MoveWindow(&rc);

	return TRUE;
}

/*********************************************************
Function:	CheckInitParam
Desc:		detect device parameters and update parameter display on the dialog box
Input:	
Output:	
Return:	TRUE,correct parameter, update paramerter display; FALSE, do not initial
**********************************************************/
BOOL CSubDlgDeviceCfg::CheckInitParam()
{
	int iDeviceIndex = g_pMainDlg->GetCurDeviceIndex();
	DWORD dwReturned = 0;
	CString sTemp;
	char szLan[128] = {0};
	m_iTypeNum = 0;
	m_comboDeviceType.ResetContent();
	m_comboDeviceType.AddString("DVR");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR);
	m_iTypeNum++;
	m_comboDeviceType.AddString("ATMDVR");
	m_comboDeviceType.SetItemData(m_iTypeNum, ATMDVR);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVS");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVS);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DEC");
	m_comboDeviceType.SetItemData(m_iTypeNum, DEC);
	m_iTypeNum++;
	m_comboDeviceType.AddString("ENC_DEC");
	m_comboDeviceType.SetItemData(m_iTypeNum, ENC_DEC);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HC");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HC);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HT");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HT);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HF");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HF);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HS");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HS);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HTS");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HTS);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HB");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HB);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HCS");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HCS);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVS_A");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVS_A);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HC_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HC_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HT_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HT_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HF_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HS_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HS_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("ATMDVR_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, ATMDVR_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("LOWCOST_DVR");
	m_comboDeviceType.SetItemData(m_iTypeNum, LOWCOST_DVR);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DEC_MAT");
	m_comboDeviceType.SetItemData(m_iTypeNum, DEC_MAT);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_MOBILE");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_MOBILE);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HD_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HD_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HD_SL");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HD_SL);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HC_SL");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HC_SL);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVR_HS_ST");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVR_HS_ST);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DVS_HW");
	m_comboDeviceType.SetItemData(m_iTypeNum, DVS_HW);
	m_iTypeNum++;
	m_comboDeviceType.AddString("IPCAM");
	m_comboDeviceType.SetItemData(m_iTypeNum, IPCAM);
	m_iTypeNum++;
	m_comboDeviceType.AddString("MEGA_IPCAM");
	m_comboDeviceType.SetItemData(m_iTypeNum, MEGA_IPCAM);
	m_iTypeNum++;
	m_comboDeviceType.AddString("IPCAM_X62MF");
	m_comboDeviceType.SetItemData(m_iTypeNum, IPCAM_X62MF);
	m_iTypeNum++;
	m_comboDeviceType.AddString("IPDOME");
	m_comboDeviceType.SetItemData(m_iTypeNum, IPDOME);
	m_iTypeNum++;
	m_comboDeviceType.AddString("IPMOD");
	m_comboDeviceType.SetItemData(m_iTypeNum, IPMOD);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS71XX_H");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS71XX_H);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS72XX_H_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS72XX_H_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS73XX_H_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS73XX_H_S);
	m_iTypeNum++;

	m_comboDeviceType.AddString("DS81XX_HS_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HS_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_HL_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HL_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_HC_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HC_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_HD_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HD_S);
	m_iTypeNum++;
	
	m_comboDeviceType.AddString("DS81XX_HE_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HE_S);
	m_iTypeNum++;


	m_comboDeviceType.AddString("DS81XX_HF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_HF_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_AH_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_AH_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS81XX_AHF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS81XX_AHF_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS90XX_HF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS90XX_HF_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS91XX_HF_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS91XX_HF_S);
	m_iTypeNum++;
	m_comboDeviceType.AddString("DS91XX_HD_S");
	m_comboDeviceType.SetItemData(m_iTypeNum, DS91XX_HD_S);
	m_iTypeNum++;
	TRACE("there is %d types", m_iTypeNum);
	if (iDeviceIndex == -1)
	{
		return FALSE;
	}

	if (m_iDeviceIndex == iDeviceIndex)
	{
		return TRUE;
	}
	else
	{
		//update parameter display on the control
		m_iDeviceIndex = iDeviceIndex;
		m_lLoginID = g_struDeviceInfo[m_iDeviceIndex].lLoginID;
		m_lStartChannel = g_struDeviceInfo[m_iDeviceIndex].iStartChan;
		m_iChanCount = g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum;
	}

	m_csDeviceName = _T("");
	m_iHdNum = 0;
	m_iYKQID = 0;
	m_csIPResolver = _T("");
	m_csDeviceIP = _T("");
	m_csMultiIP = _T("");
	m_iMainPort = 0;
	m_csGatewayIP = _T("");
	m_csIPMask = _T("");
	m_csDeviceSerialNo = _T("");
	m_csSoftwareVersion = _T("");
	m_csHardwareVersion = _T("");
	m_csPanelVersion = _T("");
	m_csDspVersion = _T("");
	m_iAlarmInNum = 0;
	m_iAlarmOutNum = 0;
	m_iChanNum = 0;
	m_csMacAddr = _T("");
	m_csRemoteManageHost1IP = _T("");
	m_iRemoteManageHost1Port = 0;

	m_csAuxoManageHostIP = _T("");
	m_iAuxoManagePort = 0;
	m_iHttpPort = 0;

	m_comboUseZoom.SetCurSel(-1);

	if (m_lLoginID < 0)
	{
		return FALSE;
	}

	if ((g_pMainDlg->IsCurDevMatDec(iDeviceIndex)))
	{
		GetDlgItem(IDC_BTN_ADVANCE_NET_SETUP)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_ZONE)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_REMOTE_NET_NFS)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_MAT_DEC_DNS)->ShowWindow(SW_SHOW);
	}
	else
	{
		GetDlgItem(IDC_BTN_ADVANCE_NET_SETUP)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_ZONE)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_REMOTE_NET_NFS)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BTN_MAT_DEC_DNS)->ShowWindow(SW_HIDE);
	}

	m_bSetDeviceCfg = FALSE;
	memset(&m_struDeviceCfg, 0, sizeof(NET_DVR_DEVICECFG));
	memset(&m_struNetCfg, 0, sizeof(NET_DVR_NETCFG_V30));
	m_dwUseZoom = 0;
	if (!NET_DVR_GetDVRConfig(m_lLoginID, NET_DVR_GET_DEVICECFG, 0,&m_struDeviceCfg, sizeof(NET_DVR_DEVICECFG), &dwReturned))
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GET_DEVICECFG");
		g_StringLanType(szLan, "ȡ豸ʧ", "Get Device Configure failed");
		AfxMessageBox(szLan);
	//	return FALSE;
	}
	else
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GET_DEVICECFG");
	}

	if (!NET_DVR_GetDVRConfig(m_lLoginID, NET_DVR_GET_NETCFG_V30, 0,&m_struNetCfg, sizeof(NET_DVR_NETCFG_V30), &dwReturned))
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GET_NETCFG_V30");
		g_StringLanType(szLan, "ȡʧ", "Get Network Configure failed");
		AfxMessageBox(szLan);
	}
	else
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GET_NETCFG_V30");
	}

	if (!NET_DVR_GetScaleCFG_V30(m_lLoginID, &m_struScale))
	{
		m_bSupScale = FALSE;
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GetScaleCFG_V30");
	}
	else
	{
		m_bSupScale = TRUE;	
	}
	UpdateData(FALSE);
	return TRUE;
}

/*********************************************************
Function:	CurCfgUpdate
Desc:		update parameter and refresh control display
Input:	
Output:	
Return:	
**********************************************************/
void CSubDlgDeviceCfg::CurCfgUpdate()
{
	if (!CheckInitParam())
	{
		UpdateData(FALSE);
		EnableWindow(FALSE);
		return;
	}
	EnableWindow(TRUE);
	
	char cTemp[200] = {0};
	if (m_bSupScale)
	{		
		GetDlgItem(IDC_STATICSCALE)->ShowWindow(SW_SHOW);
		m_comboUseZoom.ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC_MAJOR)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC_MINOR)->ShowWindow(SW_SHOW);
		m_comboMinor.ShowWindow(SW_SHOW);
		m_comboUseZoom.SetCurSel(m_struScale.dwMajorScale);	
		m_comboMinor.SetCurSel(m_struScale.dwMinorScale);	
	}
	else
	{
		GetDlgItem(IDC_STATICSCALE)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC_MAJOR)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC_MINOR)->ShowWindow(SW_HIDE);
		m_comboUseZoom.ShowWindow(SW_HIDE);
		m_comboMinor.ShowWindow(SW_HIDE);
	}

	m_comboCycleRec.SetCurSel(m_struDeviceCfg.dwRecycleRecord);
	ZeroMemory(cTemp, 200);
	memcpy(cTemp, m_struDeviceCfg.sDVRName, NAME_LEN);
	m_csDeviceName.Format("%s", cTemp);
	m_iYKQID = m_struDeviceCfg.dwDVRID;
	ZeroMemory(cTemp, 200);
	memcpy(cTemp, m_struDeviceCfg.sSerialNumber, SERIALNO_LEN);
	m_csDeviceSerialNo.Format("%s", cTemp);
	if ((m_struDeviceCfg.dwSoftwareVersion>>24)&0xFF > 0)
	{
		m_csSoftwareVersion.Format("V%d.%d.%d build %02d%02d%02d",\
			(m_struDeviceCfg.dwSoftwareVersion>>24)&0xFF, (m_struDeviceCfg.dwSoftwareVersion>>16)&0xFF, m_struDeviceCfg.dwSoftwareVersion&0xFFFF, (m_struDeviceCfg.dwSoftwareBuildDate>>16)&0xFFFF, (m_struDeviceCfg.dwSoftwareBuildDate>>8)&0xFF,m_struDeviceCfg.dwSoftwareBuildDate&0xFF);
	}
	else
	{
		m_csSoftwareVersion.Format("V%d.%d build %02d%02d%02d",\
			(m_struDeviceCfg.dwSoftwareVersion>>16)&0xFFFF, m_struDeviceCfg.dwSoftwareVersion&0xFFFF, (m_struDeviceCfg.dwSoftwareBuildDate>>16)&0xFFFF, (m_struDeviceCfg.dwSoftwareBuildDate>>8)&0xFF,m_struDeviceCfg.dwSoftwareBuildDate&0xFF);
	}
	m_csDspVersion.Format("V%d.%d build %02d%02d%02d", (m_struDeviceCfg.dwDSPSoftwareVersion>>16)&0xFFFF, m_struDeviceCfg.dwDSPSoftwareVersion&0xFFFF, (m_struDeviceCfg.dwDSPSoftwareBuildDate>>16)&0xFFFF-2000, (m_struDeviceCfg.dwDSPSoftwareBuildDate>>8)&0xFF,m_struDeviceCfg.dwDSPSoftwareBuildDate&0xFF);	
	m_csHardwareVersion.Format("0x%x", m_struDeviceCfg.dwHardwareVersion);
	m_csPanelVersion.Format("V%d", m_struDeviceCfg.dwPanelVersion);

	m_iAlarmInNum = m_struDeviceCfg.byAlarmInPortNum;
	m_iAlarmOutNum = m_struDeviceCfg.byAlarmOutPortNum;
	m_iChanNum = m_struDeviceCfg.byChanNum;	
	for (int i=0; i<m_iTypeNum; i++)
	{
		if (m_comboDeviceType.GetItemData(i) == m_struDeviceCfg.byDVRType)
		{
			m_iSelType = i;
			break;
		}
	}
	m_comboDeviceType.SetCurSel(m_iSelType);

	if (m_struNetCfg.byUseDhcp == 0xff)
	{
		GetDlgItem(IDC_CHK_DHCP)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_CHK_DHCP)->EnableWindow(TRUE);
		m_bChkDhcp = m_struNetCfg.byUseDhcp;
		EnableDhcp();
	}

	m_csIPResolver = m_struNetCfg.byIpResolver;
	m_csGatewayIP = m_struNetCfg.struGatewayIpAddr.sIpV4;
	m_csDeviceIP = m_struNetCfg.struEtherNet[0].struDVRIP.sIpV4;
	m_csIPMask = m_struNetCfg.struEtherNet[0].struDVRIPMask.sIpV4;
	m_csMacAddr.Format("%02x:%02x:%02x:%02x:%02x:%02x", m_struNetCfg.struEtherNet[0].byMACAddr[0],m_struNetCfg.struEtherNet[0].byMACAddr[1],m_struNetCfg.struEtherNet[0].byMACAddr[2],m_struNetCfg.struEtherNet[0].byMACAddr[3],m_struNetCfg.struEtherNet[0].byMACAddr[4],m_struNetCfg.struEtherNet[0].byMACAddr[5]);
	m_csMultiIP = m_struNetCfg.struMulticastIpAddr.sIpV4;
	m_csDNSIP1 = m_struNetCfg.struDnsServer1IpAddr.sIpV4;
	m_csDNSIP2 = m_struNetCfg.struDnsServer2IpAddr.sIpV4;
	m_wMTU = m_struNetCfg.struEtherNet[0].wMTU;
	m_iMainPort = m_struNetCfg.struEtherNet[0].wDVRPort;
	m_iHdNum = m_struDeviceCfg.byDiskNum;
// 	m_csRemoteManageHost1IP = m_struNetCfg.struManageHost1IpAddr.sIpV4;
// 	m_iRemoteManageHost1Port = m_struNetCfg.wManageHost1Port;
// 	m_csAuxoManageHostIP = m_struNetCfg.struManageHost2IpAddr.sIpV4;
// 	m_iAuxoManagePort = m_struNetCfg.wManageHost2Port;
	m_csAlarmHostIP = m_struNetCfg.struAlarmHostIpAddr.sIpV4;
	m_iAlarmHostPort = m_struNetCfg.wAlarmHostIpPort;
	ZeroMemory(cTemp, 200);
	memcpy(cTemp, m_struNetCfg.byIpResolver, MAX_DOMAIN_NAME);
	m_csIPResolver = cTemp;

	m_comboNetFace.SetCurSel(m_struNetCfg.struEtherNet[0].dwNetInterface-1);
	m_iHttpPort = m_struNetCfg.wHttpPortNo;

	UpdateData(FALSE);
}

/*********************************************************
  Function:	CfgSetup
  Desc:		users need to click device info box and click "OK" on the network configurtaion area
  Input:	
  Output:	
  Return:	TRUE,setting succeed;FALSE, setting failed;
**********************************************************/
BOOL CSubDlgDeviceCfg::CfgSetup()
{
	CString sTemp;
	BOOL bRet = TRUE;
	char szLan[128] = {0};
	
	if (m_bSupScale)
	{
		m_struScale.dwMajorScale = m_comboUseZoom.GetCurSel();
		m_struScale.dwMinorScale = m_comboMinor.GetCurSel();
		if (!NET_DVR_SetScaleCFG_V30(m_lLoginID, &m_struScale))
		{
			g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_SetScaleCFG_V30");
			bRet = FALSE;
			//AfxMessageBox("enable scale failed!");		
		}
		else
		{
			g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_SetScaleCFG_V30");
		}
	}

	if (m_bDeviceCfgSet)
	{
		if (!NET_DVR_SetDVRConfig(m_lLoginID, NET_DVR_SET_DEVICECFG, 0,&(m_struDeviceCfg), sizeof(NET_DVR_DEVICECFG)))
		{
			g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_SET_DEVICECFG");
			//AfxMessageBox("save device info failed!");
			bRet = FALSE;
		}
		else
		{
			g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_SET_DEVICECFG");
		}
	}

	if (m_bNetCfgSet)
	{
		if (!NET_DVR_SetDVRConfig(m_lLoginID, NET_DVR_SET_NETCFG_V30, 0, &(m_struNetCfg), sizeof(NET_DVR_NETCFG_V30)))
		{
			g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_SET_NETCFG_V30");
			g_StringLanType(szLan, "ʧ", "Save Network configuration failed");
			AfxMessageBox(szLan);
			bRet = FALSE;
		}
		else
		{
			g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_SET_NETCFG_V30");
		}
		//setting succeed, save device configurtaion
		sprintf(g_struDeviceInfo[m_iDeviceIndex].chDeviceMultiIP,"%s", m_struNetCfg.struMulticastIpAddr.sIpV4);
	}
	
	return bRet;
}

/*********************************************************
  Function:	OnBnClickedBtnRemoteNetOk
  Desc:		Confirm network parameter settings
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgDeviceCfg::OnBnClickedBtnRemoteNetOk()
{
	UpdateData(TRUE);
	char szLan[128] = {0};

	if (m_iMainPort <= 0)
	{
		g_StringLanType(szLan, "Ƿ豸˿ں", "Illegal device port number");
		AfxMessageBox(szLan);
		return;
	}

	if ((m_csDeviceIP == "0.0.0.0") || (m_csDeviceIP == "") || !CheckIPStr(m_csDeviceIP))
	{
		g_StringLanType(szLan, "Ƿ豸IPַ", "Illegal device ip address");
		AfxMessageBox(szLan);
		return;
	}

	if (!CheckIPStr(m_csIPMask))
	{
		g_StringLanType(szLan, "Ƿַ", "Illegal device MAC address");
		AfxMessageBox(szLan);
		return;
	}

	if (m_comboNetFace.GetCurSel() == 5)//1000M full
	{	
		g_StringLanType(szLan, "ȷΪ1000M磬޷ٵ½豸", "Please this is 1000M network, or can not login device again");
		if (IDOK!=MessageBox(szLan, "Waring",IDOK))
		{
			return;
		}
	}

	if (!CheckIPStr(m_csMultiIP))
	{
		g_StringLanType(szLan, "ǷĶಥIPַ", "Illegal Multicast address");
		AfxMessageBox(szLan);
		return;
	}
	
	if (!CheckIPStr(m_csGatewayIP))
	{
		g_StringLanType(szLan, "ǷIPַ", "Illegal Gateway ip address");
		AfxMessageBox(szLan);
		return;
	}

	if (!CheckIPStr(m_csRemoteManageHost1IP))
	{
		g_StringLanType(szLan, "ǷĹIPַ", "Illegal Manage host ip address");
		AfxMessageBox(szLan);
		return;
	}

//Save device configuration
	m_struDeviceCfg.dwDVRID = m_iYKQID;
	memcpy(m_struDeviceCfg.sDVRName, m_csDeviceName, NAME_LEN);	
	m_struDeviceCfg.dwRecycleRecord = m_comboCycleRec.GetCurSel();
	if (m_bSupScale)
	{
		m_dwUseZoom = m_comboUseZoom.GetCurSel();	
	}
	m_bDeviceCfgSet = TRUE;

//Save network configuration
	m_struNetCfg.byUseDhcp = m_bChkDhcp;
	memcpy(m_struNetCfg.struEtherNet[0].struDVRIP.sIpV4, m_csDeviceIP, 16);
	memcpy(m_struNetCfg.struEtherNet[0].struDVRIPMask.sIpV4, m_csIPMask, 16);
	memcpy(m_struNetCfg.byIpResolver, m_csIPResolver, MAX_DOMAIN_NAME);
	//m_struNetCfg.wIpResolverPort = m_iResolverPort;
	memcpy(m_struNetCfg.struMulticastIpAddr.sIpV4, m_csMultiIP,16);
	memcpy(m_struNetCfg.struGatewayIpAddr.sIpV4, m_csGatewayIP,16);
	m_struNetCfg.struEtherNet[0].wDVRPort = m_iMainPort;
	m_struNetCfg.struEtherNet[0].wMTU = m_wMTU;
	memcpy(m_struNetCfg.struDnsServer1IpAddr.sIpV4, m_csDNSIP1,16);
	memcpy(m_struNetCfg.struDnsServer2IpAddr.sIpV4, m_csDNSIP2,16);
// 	memcpy(m_struNetCfg.struManageHost1IpAddr.sIpV4, m_csRemoteManageHost1IP,16);
// 	m_struNetCfg.wManageHost1Port = m_iRemoteManageHost1Port;
// 	memcpy(m_struNetCfg.struManageHost2IpAddr.sIpV4, m_csAuxoManageHostIP,16);
// 	m_struNetCfg.wManageHost2Port = m_iAuxoManagePort;

	memcpy(m_struNetCfg.struAlarmHostIpAddr.sIpV4, m_csAlarmHostIP,16);
	m_struNetCfg.wAlarmHostIpPort = m_iAlarmHostPort;

	m_struNetCfg.struEtherNet[0].dwNetInterface = m_comboNetFace.GetCurSel()+1;
	
	m_struNetCfg.wHttpPortNo = m_iHttpPort;
	//m_struDeviceCfg.byLockFrontPanel.GetCurSel();
	m_bNetCfgSet = TRUE;
	g_bMustReboot = g_pMainDlg->IsNeedRebootDevType();
}

/*********************************************************
  Function:	OnBnClickedBtnMatDecDns
  Desc:		Multi-channel decoder DNS settings
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgDeviceCfg::OnBnClickedBtnMatDecDns()
{
	CDlgRemoteMatDecDnsCfg dlg;

	dlg.m_lLoginID = m_lLoginID;
	dlg.DoModal();
}

/*********************************************************
  Function:	OnBnClickedBtnRemoteNetNfs
  Desc:		NFS configurtaion
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgDeviceCfg::OnBnClickedBtnRemoteNetNfs()
{
	CDlgRemoteNetNFS dlg;
	dlg.m_lServerID = m_lLoginID;
	dlg.DoModal();
}

/*********************************************************
  Function:	OnBnClickedBtnAdvanceNetSetup
  Desc:		ADvanced network settings
  Input:	
  Output:	
  Return:	
**********************************************************/
void CSubDlgDeviceCfg::OnBnClickedBtnAdvanceNetSetup()
{
	CDlgRemoteAdvanceNetConfig dlg;
	dlg.m_pPPPoECfg = &m_struNetCfg.struPPPoE;
	dlg.m_lServerID = m_lLoginID;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.DoModal();
}

/*********************************************************
  Function:	OnBtnZone
  Desc:		to configure the zone and dst
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CSubDlgDeviceCfg::OnBtnZone() 
{
	// TODO: Add your control notification handler code here
	CDlgRemoteZone dlg;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.DoModal();
}

void CSubDlgDeviceCfg::OnBtnRtsp() 
{
	// TODO: Add your control notification handler code here
	CDlgRtspConfig dlg;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.DoModal();
}

void CSubDlgDeviceCfg::OnChkDhcp() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	EnableDhcp();
}

void CSubDlgDeviceCfg::EnableDhcp()
{
	GetDlgItem(IDC_SUB_EDIT_DEVIP)->EnableWindow(!m_bChkDhcp);
	GetDlgItem(IDC_SUB_EDIT_IPMASK)->EnableWindow(!m_bChkDhcp);
	GetDlgItem(IDC_SUB_EDIT_GATEWAY)->EnableWindow(!m_bChkDhcp);
	GetDlgItem(IDC_SUB_EDIT_DNS_IP1)->EnableWindow(!m_bChkDhcp);
	GetDlgItem(IDC_SUB_DNS_IP2)->EnableWindow(!m_bChkDhcp);
}

void CSubDlgDeviceCfg::OnBtnAudiotalkcodetConfig() 
{
	// TODO: Add your control notification handler code here
	CDlgDeviceAudioTalkCode dlg;
	dlg.m_iDeviceIndex = m_iDeviceIndex;
	dlg.DoModal();
}
