/**********************************************************
FileName:    SubDlgMatDecCfg.cpp
Description:       
Date:        2008/06/02
Note: 		<Global>struct, macro refer to GeneralDef.h, global variants and API refer to ClientDemo.cpp
Modification History:      
    <version> <time>         <desc>
    <1.0    > <2008/06/02>       <created>
***********************************************************/

#include "stdafx.h"
#include "clientdemo.h"
#include "SubDlgMatDecCFG.h"
// #include "MatCenter.h"
// #include "MatColumn.h"
// #include "MatRow.h"
// #include "MatManuLink.h"
#include "MatTrans.h"
#include "MatDispChan.h"
#include "MatDynamicTest.h"
#include "MatCycLink.h"
#include "MatPlayBack.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatDecCFG dialog

/*********************************************************
  Function:	CSubDlgMatDecCfg
  Desc:		Constructor
  Input:	
  Output:	
  Return:	
**********************************************************/
CMatDecCFG::CMatDecCFG(CWnd* pParent /*=NULL*/)
	: CDialog(CMatDecCFG::IDD, pParent)
	, m_iChannelnumber(0)
	, m_lServerID(-1)
	, m_lStartChan(0)
{
	//{{AFX_DATA_INIT(CMatDecCFG)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

/*********************************************************
Function:	DoDataExchange
Desc:		the map between control and variable
Input:	
Output:	
Return:	
**********************************************************/
void CMatDecCFG::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMatDecCFG)
	DDX_Control(pDX, IDC_COMBOSWITCH, m_SwitchCombo);
	DDX_Control(pDX, IDC_COMBODECCHAN, m_DecChanCombo);
	//}}AFX_DATA_MAP
}

/*********************************************************
Function:	BEGIN_MESSAGE_MAP
Desc:		the map between control and function
Input:	
Output:	
Return:	
**********************************************************/
BEGIN_MESSAGE_MAP(CMatDecCFG, CDialog)
	//{{AFX_MSG_MAP(CMatDecCFG)
	ON_BN_CLICKED(IDC_BTN_CENTER_SET, OnBtnCenterSet)
	ON_BN_CLICKED(IDC_BUTCOLUMNSET, OnButcolumnset)
	ON_BN_CLICKED(IDC_BUTMANPLAY, OnButmanplay)
	ON_BN_CLICKED(IDC_BUTROWSET, OnButrowset)
	ON_BN_CLICKED(IDC_BTN_DEC_TRANS_SET, OnButtransset)
	ON_BN_CLICKED(IDC_DISPCHANCFG, OnDispchancfg)
	ON_BN_CLICKED(IDC_BUTDYNAMICTEST, OnButdynamictest)
	ON_BN_CLICKED(IDC_BUTCYCLINK, OnButcyclink)
	ON_BN_CLICKED(IDC_BUTTONGET, OnButtonget)
	ON_BN_CLICKED(IDC_BUTTONSET, OnButtonset)
	ON_BN_CLICKED(IDC_BUTREMOTEPLAYBACK, OnButremoteplayback)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*********************************************************
  Function:	OnInitDialog
  Desc:		Initialize the dialog
  Input:	
  Output:	
  Return:	
**********************************************************/
BOOL CMatDecCFG::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CRect rc(0, 0, 0, 0);
	GetParent()->GetClientRect(&rc);
	((CTabCtrl*)GetParent())->AdjustRect(FALSE, &rc);
	MoveWindow(&rc);

	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/*********************************************************
Function:	CurCfgUpdate
Desc:		update multi-channel decoder
Input:	
Output:	
Return:	
**********************************************************/
void CMatDecCFG::CurCfgUpdate()
{
	int iDeviceIndex = g_pMainDlg->GetCurDeviceIndex();
	if (!g_pMainDlg->IsCurDevMatDec(iDeviceIndex))
	{
		EnableWindow(FALSE);
		return;
	}
	if (iDeviceIndex == -1)
	{
		EnableWindow(FALSE);
		return;
	}
	else
	{
		m_lServerID = g_struDeviceInfo[iDeviceIndex].lLoginID;
		m_iChannelnumber = g_struDeviceInfo[iDeviceIndex].iDeviceChanNum;
		m_lStartChan = g_struDeviceInfo[iDeviceIndex].iStartChan;
		EnableWindow(TRUE);
	}

    CString tmp;
    int i=0;
    int ChanNo = -1;
    char szLan[128] = {0};
    m_DecChanCombo.ResetContent();        
    for(i = 0; i < m_iChannelnumber; i++)
    {
        ChanNo = m_lStartChan + i;
        g_StringLanType(szLan, "ͨ", "Chan");
        tmp.Format("%s %d", szLan, ChanNo);
        m_DecChanCombo.AddString(tmp);
        //get decoder channel status/info
        // GetChanStatus(ChanNo, i);
    }
	UpdateData(FALSE);
}

/*********************************************************
  Function:	OnBtnCenterSet
  Desc:		matrix settings
  Input:	
  Output:	
  Return:	
**********************************************************/
void CMatDecCFG::OnBtnCenterSet() 
{

// 	CMatCenter dlg;
// 	dlg.m_iChannelnumber = m_iChannelnumber;
// 	dlg.m_lServerID = m_lServerID;
// 	dlg.m_lStartChan = m_lStartChan;
// 	dlg.DoModal();
}

/*********************************************************
  Function:	OnButcolumnset
  Desc:		matrix column settings
  Input:	
  Output:	
  Return:	
**********************************************************/
void CMatDecCFG::OnButcolumnset() 
{
// 
// 	CMatColumn dlg;
// 	dlg.m_iChannelnumber = m_iChannelnumber;
// 	dlg.m_lServerID = m_lServerID;
// 	dlg.m_lStartChan = m_lStartChan;	
// 	dlg.DoModal();
}

/*********************************************************
  Function:	OnButmanplay
  Desc:		manual p[layback
  Input:	
  Output:	
  Return:	
**********************************************************/
void CMatDecCFG::OnButmanplay() 
{

// 	CMatManuLink dlg;
// 	dlg.m_iChannelnumber = m_iChannelnumber;
// 	dlg.m_lServerID = m_lServerID;
// 	dlg.m_lStartChan = m_lStartChan;
// 	dlg.DoModal();
}

/*********************************************************
  Function:	OnButrowset
  Desc:		to set mattix row
  Input:	
  Output:	
  Return:	
**********************************************************/
void CMatDecCFG::OnButrowset() 
{

// 	CMatRow dlg;
// 	dlg.m_iChannelnumber = m_iChannelnumber;
// 	dlg.m_lServerID = m_lServerID;
// 	dlg.m_lStartChan = m_lStartChan;	
// 	dlg.DoModal();
}

/*********************************************************
  Function:	OnButtransset
  Desc:		to set the transparent
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CMatDecCFG::OnButtransset() 
{

	CMatTrans dlg;
	dlg.m_iChannelnumber = m_iChannelnumber;
	dlg.m_lServerID = m_lServerID;
	dlg.m_lStartChan = m_lStartChan;
	dlg.DoModal();
}

/*********************************************************
  Function:	OnDispchancfg
  Desc:		to setup the configure of the display channel
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CMatDecCFG::OnDispchancfg() 
{
	
	CMatDispChan dlg;
	dlg.m_iChannelnumber = m_iChannelnumber;
	dlg.m_lServerID = m_lServerID;
	dlg.m_lStartChan = m_lStartChan;	
	dlg.DoModal();
}

/*********************************************************
  Function:	OnButdynamictest
  Desc:		to set the dynamic configure
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CMatDecCFG::OnButdynamictest() 
{
	
	CMatDynamicTest mdt;
	mdt.m_lServerID = m_lServerID;
	mdt.m_lStartChan = m_lStartChan;
	mdt.m_iChannelnumber = m_iChannelnumber;
	mdt.DoModal();
}

/*********************************************************
  Function:	OnButcyclink
  Desc:		to setup cycle link
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CMatDecCFG::OnButcyclink() 
{
	
	CMatCycLink mcl;
	mcl.m_lServerID = m_lServerID;
	mcl.m_lStartChan = m_lStartChan;
	mcl.m_iChannelnumber = m_iChannelnumber;
	mcl.DoModal();
}

/*********************************************************
  Function:	OnButtonget
  Desc:		to get the status of the channels
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CMatDecCFG::OnButtonget() 
{
	
	UpdateData(TRUE);
	
	int sel = m_DecChanCombo.GetCurSel();
	
	CString tmp;
	DWORD dec = 0;
	if (!NET_DVR_MatrixGetDecChanEnable(m_lServerID, sel+m_lStartChan, &dec))
	{
		tmp.Format("Error: NET_DVR_MatrixGetDecChanEnable = %d", NET_DVR_GetLastError());
		AfxMessageBox(tmp);
// 		m_Switch[sel] = 0xff;
	}
	else
	{
	// 	m_Switch[sel] = dec;
		m_SwitchCombo.SetCurSel(dec);
	}
	UpdateData(FALSE);
}

/*********************************************************
  Function:	OnButtonset
  Desc:		to set the status of the channels
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CMatDecCFG::OnButtonset() 
{
	
	UpdateData(TRUE);
	
	CString tmp;
	if (!NET_DVR_MatrixSetDecChanEnable(m_lServerID, m_DecChanCombo.GetCurSel()+m_lStartChan, m_SwitchCombo.GetCurSel()))
	{
		tmp.Format("Error: NET_DVR_MatrixSetDecChanEnable = %d", NET_DVR_GetLastError());
		AfxMessageBox(tmp);
		return;
	}
	char szLan[128] = {0};
	g_StringLanType(szLan, "óɹ", "Set successfully");
	AfxMessageBox(szLan);
}

/*********************************************************
  Function:	OnButremoteplayback
  Desc:		to play back remotely
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CMatDecCFG::OnButremoteplayback() 
{
	
	CMatPlayBack pl;
	pl.m_lServerID = m_lServerID;
	pl.m_iChannelNumber = m_iChannelnumber;
	pl.m_lStartChan = m_lStartChan;
	pl.DoModal();
}
